*** ../gcc.orig/./doc/extend.texi	2011-05-12 12:34:14.000000000 +0300
--- ./doc/extend.texi	2011-11-15 08:40:07.000000000 +0200
***************
*** 7255,7260 ****
--- 7255,7277 ----
  v8hi __builtin_ia32_pabsw128 (v8hi)
  @end smallexample
  
+ The following built-in functions are available when @option{-msse4a} is used.
+ 
+ @smallexample
+ void             _mm_stream_sd (double*,__m128d);
+ Generates the @code{movntsd} machine instruction.
+ void             _mm_stream_ss (float*,__m128);
+ Generates the @code{movntss} machine instruction.
+ __m128i          _mm_extract_si64 (__m128i, __m128i);
+ Generates the @code{extrq} machine instruction with only SSE register operands.
+ __m128i          _mm_extracti_si64 (__m128i, int, int);
+ Generates the @code{extrq} machine instruction with SSE register and immediate operands.
+ __m128i          _mm_insert_si64 (__m128i, __m128i);
+ Generates the @code{insertq} machine instruction with only SSE register operands.
+ __m128i          _mm_inserti_si64 (__m128i, __m128i, int, int);
+ Generates the @code{insertq} machine instruction with SSE register and immediate operands.
+ @end smallexample
+ 
  The following built-in functions are available when @option{-m3dnow} is used.
  All of them generate the machine instruction that is part of the name.
  
*** ../gcc.orig/./doc/invoke.texi	2011-05-12 12:34:14.000000000 +0300
--- ./doc/invoke.texi	2011-11-15 09:36:04.000000000 +0200
***************
*** 513,519 ****
  -mno-fp-ret-in-387  -msoft-float  -msvr3-shlib @gol
  -mno-wide-multiply  -mrtd  -malign-double @gol
  -mpreferred-stack-boundary=@var{num} @gol
! -mmmx  -msse  -msse2 -msse3 -mssse3 -m3dnow @gol
  -mthreads  -mno-align-stringops  -minline-all-stringops @gol
  -mpush-args  -maccumulate-outgoing-args  -m128bit-long-double @gol
  -m96bit-long-double  -mregparm=@var{num}  -msseregparm @gol
--- 513,519 ----
  -mno-fp-ret-in-387  -msoft-float  -msvr3-shlib @gol
  -mno-wide-multiply  -mrtd  -malign-double @gol
  -mpreferred-stack-boundary=@var{num} @gol
! -mmmx  -msse  -msse2 -msse3 -mssse3 -msse4a -m3dnow -mpopcnt -mabm @gol
  -mthreads  -mno-align-stringops  -minline-all-stringops @gol
  -mpush-args  -maccumulate-outgoing-args  -m128bit-long-double @gol
  -m96bit-long-double  -mregparm=@var{num}  -msseregparm @gol
***************
*** 9061,9066 ****
--- 9061,9070 ----
  MMX, SSE, SSE2, 3dNOW!, enhanced 3dNOW! and 64-bit instruction set extensions.)
  @item k8-sse3, opteron-sse3, athlon64-sse3
  Improved versions of k8, opteron and athlon64 with SSE3 instruction set support.
+ @item amdfam10, barcelona
+ AMD Family 10h core based CPUs with x86-64 instruction set support.  (This
+ supersets MMX, SSE, SSE2, SSE3, SSE4A, 3dNOW!, enhanced 3dNOW!, ABM and 64-bit
+ instruction set extensions.)
  @item winchip-c6
  IDT Winchip C6 CPU, dealt in same way as i486 with additional MMX instruction
  set support.
***************
*** 9355,9362 ****
--- 9359,9372 ----
  @itemx -mno-sse3
  @item -mssse3
  @itemx -mno-ssse3
+ @item -msse4a
+ @item -mno-sse4a
  @item -m3dnow
  @itemx -mno-3dnow
+ @item -mpopcnt
+ @itemx -mno-popcnt
+ @item -mabm
+ @itemx -mno-abm
  @opindex mmmx
  @opindex mno-mmx
  @opindex msse
***************
*** 9364,9370 ****
  @opindex m3dnow
  @opindex mno-3dnow
  These switches enable or disable the use of instructions in the MMX,
! SSE, SSE2, SSE3, SSSE3 or 3DNow! extended instruction sets.
  These extensions are also available as built-in functions: see
  @ref{X86 Built-in Functions}, for details of the functions enabled and
  disabled by these switches.
--- 9374,9380 ----
  @opindex m3dnow
  @opindex mno-3dnow
  These switches enable or disable the use of instructions in the MMX,
! SSE, SSE2, SSE3, SSSE3, SSE4A, ABM or 3DNow! extended instruction sets.
  These extensions are also available as built-in functions: see
  @ref{X86 Built-in Functions}, for details of the functions enabled and
  disabled by these switches.
*** ../gcc.orig/./config/i386/emmintrin.h	2011-05-12 12:34:22.000000000 +0300
--- ./config/i386/emmintrin.h	2011-11-15 08:40:11.000000000 +0200
***************
*** 30,36 ****
  #ifndef _EMMINTRIN_H_INCLUDED
  #define _EMMINTRIN_H_INCLUDED
  
! #ifdef __SSE2__
  #include <xmmintrin.h>
  
  /* SSE2 */
--- 30,40 ----
  #ifndef _EMMINTRIN_H_INCLUDED
  #define _EMMINTRIN_H_INCLUDED
  
! #ifndef __SSE2__
! # error "SSE2 instruction set not enabled"
! #else
! 
! /* We need definitions from the SSE header files*/
  #include <xmmintrin.h>
  
  /* SSE2 */
*** ../gcc.orig/./config/i386/i386.h	2011-05-12 12:34:22.000000000 +0300
--- ./config/i386/i386.h	2011-11-15 08:47:35.000000000 +0200
***************
*** 141,146 ****
--- 141,147 ----
  #define TARGET_GENERIC32 (ix86_tune == PROCESSOR_GENERIC32)
  #define TARGET_GENERIC64 (ix86_tune == PROCESSOR_GENERIC64)
  #define TARGET_GENERIC (TARGET_GENERIC32 || TARGET_GENERIC64)
+ #define TARGET_AMDFAM10 (ix86_tune == PROCESSOR_AMDFAM10)
  
  #define TUNEMASK (1 << ix86_tune)
  extern const int x86_use_leave, x86_push_memory, x86_zero_extend_with_and;
***************
*** 159,164 ****
--- 160,166 ----
  extern const int x86_epilogue_using_move, x86_decompose_lea;
  extern const int x86_arch_always_fancy_math_387, x86_shift1;
  extern const int x86_sse_partial_reg_dependency, x86_sse_split_regs;
+ extern const int x86_sse_unaligned_move_optimal;
  extern const int x86_sse_typeless_stores, x86_sse_load0_by_pxor;
  extern const int x86_use_ffreep;
  extern const int x86_inter_unit_moves, x86_schedule;
***************
*** 207,212 ****
--- 209,216 ----
  #define TARGET_PARTIAL_REG_DEPENDENCY (x86_partial_reg_dependency & TUNEMASK)
  #define TARGET_SSE_PARTIAL_REG_DEPENDENCY \
  				      (x86_sse_partial_reg_dependency & TUNEMASK)
+ #define TARGET_SSE_UNALIGNED_MOVE_OPTIMAL \
+ 				      (x86_sse_unaligned_move_optimal & TUNEMASK)
  #define TARGET_SSE_SPLIT_REGS (x86_sse_split_regs & TUNEMASK)
  #define TARGET_SSE_TYPELESS_STORES (x86_sse_typeless_stores & TUNEMASK)
  #define TARGET_SSE_LOAD0_BY_PXOR (x86_sse_load0_by_pxor & TUNEMASK)
***************
*** 399,404 ****
--- 403,410 ----
  	}							\
        else if (TARGET_K8)					\
  	builtin_define ("__tune_k8__");				\
+       else if (TARGET_AMDFAM10)					\
+ 	builtin_define ("__tune_amdfam10__");			\
        else if (TARGET_PENTIUM4)					\
  	builtin_define ("__tune_pentium4__");			\
        else if (TARGET_NOCONA)					\
***************
*** 420,425 ****
--- 426,433 ----
  	builtin_define ("__SSE3__");				\
        if (TARGET_SSSE3)						\
  	builtin_define ("__SSSE3__");				\
+       if (TARGET_SSE4A)					\
+  	builtin_define ("__SSE4A__");		                \
        if (TARGET_SSE_MATH && TARGET_SSE)			\
  	builtin_define ("__SSE_MATH__");			\
        if (TARGET_SSE_MATH && TARGET_SSE2)			\
***************
*** 475,480 ****
--- 483,493 ----
  	  builtin_define ("__k8");				\
  	  builtin_define ("__k8__");				\
  	}							\
+       else if (ix86_arch == PROCESSOR_AMDFAM10)			\
+ 	{							\
+ 	  builtin_define ("__amdfam10");			\
+ 	  builtin_define ("__amdfam10__");			\
+ 	}							\
        else if (ix86_arch == PROCESSOR_PENTIUM4)			\
  	{							\
  	  builtin_define ("__pentium4");			\
***************
*** 513,525 ****
  #define TARGET_CPU_DEFAULT_nocona 17
  #define TARGET_CPU_DEFAULT_core2 18
  #define TARGET_CPU_DEFAULT_generic 19
  
  #define TARGET_CPU_DEFAULT_NAMES {"i386", "i486", "pentium", "pentium-mmx",\
  				  "pentiumpro", "pentium2", "pentium3", \
                                    "pentium4", "geode", "k6", "k6-2", "k6-3", \
  				  "athlon", "athlon-4", "k8", \
  				  "pentium-m", "prescott", "nocona", \
! 				  "core2", "generic"}
  
  #ifndef CC1_SPEC
  #define CC1_SPEC "%(cc1_cpu) "
--- 526,539 ----
  #define TARGET_CPU_DEFAULT_nocona 17
  #define TARGET_CPU_DEFAULT_core2 18
  #define TARGET_CPU_DEFAULT_generic 19
+ #define TARGET_CPU_DEFAULT_amdfam10 20
  
  #define TARGET_CPU_DEFAULT_NAMES {"i386", "i486", "pentium", "pentium-mmx",\
  				  "pentiumpro", "pentium2", "pentium3", \
                                    "pentium4", "geode", "k6", "k6-2", "k6-3", \
  				  "athlon", "athlon-4", "k8", \
  				  "pentium-m", "prescott", "nocona", \
! 				  "core2", "generic", "amdfam10"}
  
  #ifndef CC1_SPEC
  #define CC1_SPEC "%(cc1_cpu) "
***************
*** 2108,2113 ****
--- 2122,2128 ----
    PROCESSOR_CORE2,
    PROCESSOR_GENERIC32,
    PROCESSOR_GENERIC64,
+   PROCESSOR_AMDFAM10,
    PROCESSOR_max
  };
  
*** ../gcc.orig/./config/i386/i386.c	2011-03-17 11:44:33.000000000 +0200
--- ./config/i386/i386.c	2011-11-15 09:35:18.000000000 +0200
***************
*** 548,553 ****
--- 548,618 ----
    COSTS_N_INSNS (35),			/* cost of FSQRT instruction.  */
  };
  
+ struct processor_costs amdfam10_cost = {
+   COSTS_N_INSNS (1),                    /* cost of an add instruction */
+   COSTS_N_INSNS (2),                    /* cost of a lea instruction */
+   COSTS_N_INSNS (1),                    /* variable shift costs */
+   COSTS_N_INSNS (1),                    /* constant shift costs */
+   {COSTS_N_INSNS (3),                   /* cost of starting multiply for QI */
+    COSTS_N_INSNS (4),                   /*                               HI */
+    COSTS_N_INSNS (3),                   /*                               SI */
+    COSTS_N_INSNS (4),                   /*                               DI */
+    COSTS_N_INSNS (5)},                  /*                               other */
+   0,                                    /* cost of multiply per each bit set */
+   {COSTS_N_INSNS (19),                  /* cost of a divide/mod for QI */
+    COSTS_N_INSNS (35),                  /*                          HI */
+    COSTS_N_INSNS (51),                  /*                          SI */
+    COSTS_N_INSNS (83),                  /*                          DI */
+    COSTS_N_INSNS (83)},                 /*                          other */
+   COSTS_N_INSNS (1),			/* cost of movsx */
+   COSTS_N_INSNS (1),			/* cost of movzx */
+   8,					/* "large" insn */
+   9,					/* MOVE_RATIO */
+   4,					/* cost for loading QImode using movzbl */
+   {3, 4, 3},				/* cost of loading integer registers
+ 					   in QImode, HImode and SImode.
+ 					   Relative to reg-reg move (2).  */
+   {3, 4, 3},				/* cost of storing integer registers */
+   4,					/* cost of reg,reg fld/fst */
+   {4, 4, 12},				/* cost of loading fp registers
+ 		   			   in SFmode, DFmode and XFmode */
+   {6, 6, 8},				/* cost of storing fp registers
+  		   			   in SFmode, DFmode and XFmode */
+   2,					/* cost of moving MMX register */
+   {3, 3},				/* cost of loading MMX registers
+ 					   in SImode and DImode */
+   {4, 4},				/* cost of storing MMX registers
+ 					   in SImode and DImode */
+   2,					/* cost of moving SSE register */
+   {4, 4, 3},				/* cost of loading SSE registers
+ 					   in SImode, DImode and TImode */
+   {4, 4, 5},				/* cost of storing SSE registers
+ 					   in SImode, DImode and TImode */
+   3,					/* MMX or SSE register to integer */
+   					/* On K8
+   					    MOVD reg64, xmmreg 	Double	FSTORE 4
+ 					    MOVD reg32, xmmreg 	Double	FSTORE 4
+ 					   On AMDFAM10
+ 					    MOVD reg64, xmmreg 	Double	FADD 3
+                                                                 1/1  1/1
+ 					    MOVD reg32, xmmreg 	Double	FADD 3
+                                                                 1/1  1/1 */
+   64,					/* size of prefetch block */
+   /* New AMD processors never drop prefetches; if they cannot be performed
+      immediately, they are queued.  We set number of simultaneous prefetches
+      to a large constant to reflect this (it probably is not a good idea not
+      to limit number of prefetches at all, as their execution also takes some
+      time).  */
+   100,					/* number of parallel prefetches */
+   5,					/* Branch cost */
+   COSTS_N_INSNS (4),			/* cost of FADD and FSUB insns.  */
+   COSTS_N_INSNS (4),			/* cost of FMUL instruction.  */
+   COSTS_N_INSNS (19),			/* cost of FDIV instruction.  */
+   COSTS_N_INSNS (2),			/* cost of FABS instruction.  */
+   COSTS_N_INSNS (2),			/* cost of FCHS instruction.  */
+   COSTS_N_INSNS (35),			/* cost of FSQRT instruction.  */
+ };
+ 
  static const
  struct processor_costs pentium4_cost = {
    COSTS_N_INSNS (1),			/* cost of an add instruction */
***************
*** 834,844 ****
--- 899,911 ----
  #define m_PENT4  (1<<PROCESSOR_PENTIUM4)
  #define m_K8  (1<<PROCESSOR_K8)
  #define m_ATHLON_K8  (m_K8 | m_ATHLON)
+ #define m_AMDFAM10  (1<<PROCESSOR_AMDFAM10)
  #define m_NOCONA  (1<<PROCESSOR_NOCONA)
  #define m_CORE2  (1<<PROCESSOR_CORE2)
  #define m_GENERIC32 (1<<PROCESSOR_GENERIC32)
  #define m_GENERIC64 (1<<PROCESSOR_GENERIC64)
  #define m_GENERIC (m_GENERIC32 | m_GENERIC64)
+ #define m_ATHLON_K8_AMDFAM10  (m_K8 | m_ATHLON | m_AMDFAM10)
  
  /* Generic instruction choice should be common subset of supported CPUs
     (PPro/PENT4/NOCONA/CORE2/Athlon/K8).  */
***************
*** 846,861 ****
  /* Leave is not affecting Nocona SPEC2000 results negatively, so enabling for
     Generic64 seems like good code size tradeoff.  We can't enable it for 32bit
     generic because it is not working well with PPro base chips.  */
! const int x86_use_leave = m_386 | m_K6_GEODE | m_ATHLON_K8 | m_CORE2 | m_GENERIC64;
! const int x86_push_memory = m_386 | m_K6_GEODE | m_ATHLON_K8 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
  const int x86_zero_extend_with_and = m_486 | m_PENT;
! const int x86_movx = m_ATHLON_K8 | m_PPRO | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC | m_GEODE /* m_386 | m_K6 */;
  const int x86_double_with_add = ~m_386;
  const int x86_use_bit_test = m_386;
! const int x86_unroll_strlen = m_486 | m_PENT | m_PPRO | m_ATHLON_K8 | m_K6 | m_CORE2 | m_GENERIC;
! const int x86_cmove = m_PPRO | m_GEODE | m_ATHLON_K8 | m_PENT4 | m_NOCONA;
! const int x86_3dnow_a = m_ATHLON_K8;
! const int x86_deep_branch = m_PPRO | m_K6_GEODE | m_ATHLON_K8 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
  /* Branch hints were put in P4 based on simulation result. But
     after P4 was made, no performance benefit was observed with
     branch hints. It also increases the code size. As the result,
--- 913,928 ----
  /* Leave is not affecting Nocona SPEC2000 results negatively, so enabling for
     Generic64 seems like good code size tradeoff.  We can't enable it for 32bit
     generic because it is not working well with PPro base chips.  */
! const int x86_use_leave = m_386 | m_K6_GEODE | m_ATHLON_K8_AMDFAM10 | m_CORE2 | m_GENERIC64;
! const int x86_push_memory = m_386 | m_K6_GEODE | m_ATHLON_K8_AMDFAM10 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
  const int x86_zero_extend_with_and = m_486 | m_PENT;
! const int x86_movx = m_ATHLON_K8_AMDFAM10 | m_PPRO | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC | m_GEODE /* m_386 | m_K6 */;
  const int x86_double_with_add = ~m_386;
  const int x86_use_bit_test = m_386;
! const int x86_unroll_strlen = m_486 | m_PENT | m_PPRO | m_ATHLON_K8_AMDFAM10 | m_K6 | m_CORE2 | m_GENERIC;
! const int x86_cmove = m_PPRO | m_GEODE | m_ATHLON_K8_AMDFAM10 | m_PENT4 | m_NOCONA;
! const int x86_3dnow_a = m_ATHLON_K8_AMDFAM10 ;
! const int x86_deep_branch = m_PPRO | m_K6_GEODE | m_ATHLON_K8_AMDFAM10 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
  /* Branch hints were put in P4 based on simulation result. But
     after P4 was made, no performance benefit was observed with
     branch hints. It also increases the code size. As the result,
***************
*** 873,885 ****
  const int x86_partial_reg_stall = m_PPRO;
  const int x86_partial_flag_reg_stall =  m_CORE2 | m_GENERIC;
  const int x86_use_himode_fiop = m_386 | m_486 | m_K6_GEODE;
! const int x86_use_simode_fiop = ~(m_PPRO | m_ATHLON_K8 | m_PENT | m_CORE2 | m_GENERIC);
  const int x86_use_mov0 = m_K6;
  const int x86_use_cltd = ~(m_PENT | m_K6 | m_CORE2 | m_GENERIC);
  const int x86_read_modify_write = ~m_PENT;
  const int x86_read_modify = ~(m_PENT | m_PPRO);
  const int x86_split_long_moves = m_PPRO;
! const int x86_promote_QImode = m_K6_GEODE | m_PENT | m_386 | m_486 | m_ATHLON_K8 | m_CORE2 | m_GENERIC; /* m_PENT4 ? */
  const int x86_fast_prefix = ~(m_PENT | m_486 | m_386);
  const int x86_single_stringop = m_386 | m_PENT4 | m_NOCONA;
  const int x86_qimode_math = ~(0);
--- 940,952 ----
  const int x86_partial_reg_stall = m_PPRO;
  const int x86_partial_flag_reg_stall =  m_CORE2 | m_GENERIC;
  const int x86_use_himode_fiop = m_386 | m_486 | m_K6_GEODE;
! const int x86_use_simode_fiop = ~(m_PPRO | m_ATHLON_K8_AMDFAM10 | m_PENT | m_CORE2 | m_GENERIC);
  const int x86_use_mov0 = m_K6;
  const int x86_use_cltd = ~(m_PENT | m_K6 | m_CORE2 | m_GENERIC);
  const int x86_read_modify_write = ~m_PENT;
  const int x86_read_modify = ~(m_PENT | m_PPRO);
  const int x86_split_long_moves = m_PPRO;
! const int x86_promote_QImode = m_K6_GEODE | m_PENT | m_386 | m_486 | m_ATHLON_K8_AMDFAM10 | m_CORE2 | m_GENERIC; /* m_PENT4 ? */
  const int x86_fast_prefix = ~(m_PENT | m_486 | m_386);
  const int x86_single_stringop = m_386 | m_PENT4 | m_NOCONA;
  const int x86_qimode_math = ~(0);
***************
*** 889,906 ****
     if our scheme for avoiding partial stalls was more effective.  */
  const int x86_himode_math = ~(m_PPRO);
  const int x86_promote_hi_regs = m_PPRO;
! const int x86_sub_esp_4 = m_ATHLON_K8 | m_PPRO | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_sub_esp_8 = m_ATHLON_K8 | m_PPRO | m_386 | m_486 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_add_esp_4 = m_ATHLON_K8 | m_K6_GEODE | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_add_esp_8 = m_ATHLON_K8 | m_PPRO | m_K6_GEODE | m_386 | m_486 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_integer_DFmode_moves = ~(m_ATHLON_K8 | m_PENT4 | m_NOCONA | m_PPRO | m_CORE2 | m_GENERIC | m_GEODE);
! const int x86_partial_reg_dependency = m_ATHLON_K8 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_memory_mismatch_stall = m_ATHLON_K8 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_accumulate_outgoing_args = m_ATHLON_K8 | m_PENT4 | m_NOCONA | m_PPRO | m_CORE2 | m_GENERIC;
  const int x86_prologue_using_move = m_ATHLON_K8 | m_PPRO | m_CORE2 | m_GENERIC;
  const int x86_epilogue_using_move = m_ATHLON_K8 | m_PPRO | m_CORE2 | m_GENERIC;
  const int x86_shift1 = ~m_486;
! const int x86_arch_always_fancy_math_387 = m_PENT | m_PPRO | m_ATHLON_K8 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
  /* In Generic model we have an conflict here in between PPro/Pentium4 based chips
     that thread 128bit SSE registers as single units versus K8 based chips that
     divide SSE registers to two 64bit halves.
--- 956,973 ----
     if our scheme for avoiding partial stalls was more effective.  */
  const int x86_himode_math = ~(m_PPRO);
  const int x86_promote_hi_regs = m_PPRO;
! const int x86_sub_esp_4 = m_ATHLON_K8_AMDFAM10 | m_PPRO | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_sub_esp_8 = m_ATHLON_K8_AMDFAM10 | m_PPRO | m_386 | m_486 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_add_esp_4 = m_ATHLON_K8_AMDFAM10 | m_K6_GEODE | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_add_esp_8 = m_ATHLON_K8_AMDFAM10 | m_PPRO | m_K6_GEODE | m_386 | m_486 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_integer_DFmode_moves = ~(m_ATHLON_K8_AMDFAM10 | m_PENT4 | m_NOCONA | m_PPRO | m_CORE2 | m_GENERIC | m_GEODE);
! const int x86_partial_reg_dependency = m_ATHLON_K8_AMDFAM10 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_memory_mismatch_stall = m_ATHLON_K8_AMDFAM10 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_accumulate_outgoing_args = m_ATHLON_K8_AMDFAM10 | m_PENT4 | m_NOCONA | m_PPRO | m_CORE2 | m_GENERIC;
  const int x86_prologue_using_move = m_ATHLON_K8 | m_PPRO | m_CORE2 | m_GENERIC;
  const int x86_epilogue_using_move = m_ATHLON_K8 | m_PPRO | m_CORE2 | m_GENERIC;
  const int x86_shift1 = ~m_486;
! const int x86_arch_always_fancy_math_387 = m_PENT | m_PPRO | m_ATHLON_K8_AMDFAM10 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
  /* In Generic model we have an conflict here in between PPro/Pentium4 based chips
     that thread 128bit SSE registers as single units versus K8 based chips that
     divide SSE registers to two 64bit halves.
***************
*** 910,924 ****
     this option on P4 brings over 20% SPECfp regression, while enabling it on
     K8 brings roughly 2.4% regression that can be partly masked by careful scheduling
     of moves.  */
! const int x86_sse_partial_reg_dependency = m_PENT4 | m_NOCONA | m_PPRO | m_CORE2 | m_GENERIC;
  /* Set for machines where the type and dependencies are resolved on SSE
     register parts instead of whole registers, so we may maintain just
     lower part of scalar values in proper format leaving the upper part
     undefined.  */
  const int x86_sse_split_regs = m_ATHLON_K8;
! const int x86_sse_typeless_stores = m_ATHLON_K8;
  const int x86_sse_load0_by_pxor = m_PPRO | m_PENT4 | m_NOCONA;
! const int x86_use_ffreep = m_ATHLON_K8;
  const int x86_rep_movl_optimal = m_386 | m_PENT | m_PPRO | m_K6_GEODE | m_CORE2;
  const int x86_use_incdec = ~(m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC);
  
--- 977,992 ----
     this option on P4 brings over 20% SPECfp regression, while enabling it on
     K8 brings roughly 2.4% regression that can be partly masked by careful scheduling
     of moves.  */
! const int x86_sse_partial_reg_dependency = m_PENT4 | m_NOCONA | m_PPRO | m_CORE2 | m_GENERIC | m_AMDFAM10;
  /* Set for machines where the type and dependencies are resolved on SSE
     register parts instead of whole registers, so we may maintain just
     lower part of scalar values in proper format leaving the upper part
     undefined.  */
  const int x86_sse_split_regs = m_ATHLON_K8;
! const int x86_sse_unaligned_move_optimal = m_AMDFAM10;
! const int x86_sse_typeless_stores = m_ATHLON_K8_AMDFAM10;
  const int x86_sse_load0_by_pxor = m_PPRO | m_PENT4 | m_NOCONA;
! const int x86_use_ffreep = m_ATHLON_K8_AMDFAM10;
  const int x86_rep_movl_optimal = m_386 | m_PENT | m_PPRO | m_K6_GEODE | m_CORE2;
  const int x86_use_incdec = ~(m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC);
  
***************
*** 929,937 ****
  const int x86_ext_80387_constants = m_K6_GEODE | m_ATHLON | m_PENT4 | m_NOCONA | m_CORE2 | m_PPRO | m_GENERIC32;
  /* Some CPU cores are not able to predict more than 4 branch instructions in
     the 16 byte window.  */
! const int x86_four_jump_limit = m_PPRO | m_ATHLON_K8 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_schedule = m_PPRO | m_ATHLON_K8 | m_K6_GEODE | m_PENT | m_CORE2 | m_GENERIC;
! const int x86_use_bt = m_ATHLON_K8;
  /* Compare and exchange was added for 80486.  */
  const int x86_cmpxchg = ~m_386;
  /* Compare and exchange 8 bytes was added for pentium.  */
--- 997,1005 ----
  const int x86_ext_80387_constants = m_K6_GEODE | m_ATHLON | m_PENT4 | m_NOCONA | m_CORE2 | m_PPRO | m_GENERIC32;
  /* Some CPU cores are not able to predict more than 4 branch instructions in
     the 16 byte window.  */
! const int x86_four_jump_limit = m_PPRO | m_ATHLON_K8_AMDFAM10 | m_PENT4 | m_NOCONA | m_CORE2 | m_GENERIC;
! const int x86_schedule = m_PPRO | m_ATHLON_K8_AMDFAM10 | m_K6_GEODE | m_PENT | m_CORE2 | m_GENERIC;
! const int x86_use_bt = m_ATHLON_K8_AMDFAM10;
  /* Compare and exchange was added for 80486.  */
  const int x86_cmpxchg = ~m_386;
  /* Compare and exchange 8 bytes was added for pentium.  */
***************
*** 940,946 ****
  const int x86_cmpxchg16b = m_NOCONA | m_CORE2;
  /* Exchange and add was added for 80486.  */
  const int x86_xadd = ~m_386;
! const int x86_pad_returns = m_ATHLON_K8 | m_CORE2 | m_GENERIC;
  
  /* In case the average insn count for single function invocation is
     lower than this constant, emit fast (but longer) prologue and
--- 1008,1014 ----
  const int x86_cmpxchg16b = m_NOCONA | m_CORE2;
  /* Exchange and add was added for 80486.  */
  const int x86_xadd = ~m_386;
! const int x86_pad_returns = m_ATHLON_K8_AMDFAM10 | m_CORE2 | m_GENERIC;
  
  /* In case the average insn count for single function invocation is
     lower than this constant, emit fast (but longer) prologue and
***************
*** 1511,1534 ****
      case OPT_msse:
        if (!value)
  	{
! 	  target_flags &= ~(MASK_SSE2 | MASK_SSE3 | MASK_SSSE3);
! 	  target_flags_explicit |= MASK_SSE2 | MASK_SSE3 | MASK_SSSE3;
  	}
        return true;
  
      case OPT_msse2:
        if (!value)
  	{
! 	  target_flags &= ~(MASK_SSE3 | MASK_SSSE3);
! 	  target_flags_explicit |= MASK_SSE3 | MASK_SSSE3;
  	}
        return true;
  
      case OPT_msse3:
        if (!value)
  	{
! 	  target_flags &= ~MASK_SSSE3;
! 	  target_flags_explicit |= MASK_SSSE3;
  	}
        return true;
  
--- 1579,1602 ----
      case OPT_msse:
        if (!value)
  	{
! 	  target_flags &= ~(MASK_SSE2 | MASK_SSE3 | MASK_SSE4A | MASK_SSSE3);
! 	  target_flags_explicit |= MASK_SSE2 | MASK_SSE3 | MASK_SSE4A | MASK_SSSE3;
  	}
        return true;
  
      case OPT_msse2:
        if (!value)
  	{
! 	  target_flags &= ~(MASK_SSE3 | MASK_SSE4A | MASK_SSSE3);
! 	  target_flags_explicit |= MASK_SSE3 | MASK_SSE4A | MASK_SSSE3;
  	}
        return true;
  
      case OPT_msse3:
        if (!value)
  	{
! 	  target_flags &= ~(MASK_SSE4A | MASK_SSSE3);
! 	  target_flags_explicit |= MASK_SSE4A | MASK_SSSE3;
  	}
        return true;
  
***************
*** 1580,1586 ****
        {&nocona_cost, 0, 0, 0, 0, 0, 0, 0},
        {&core2_cost, 0, 0, 16, 7, 16, 7, 16},
        {&generic32_cost, 0, 0, 16, 7, 16, 7, 16},
!       {&generic64_cost, 0, 0, 16, 7, 16, 7, 16}
      };
  
    static const char * const cpu_names[] = TARGET_CPU_DEFAULT_NAMES;
--- 1648,1655 ----
        {&nocona_cost, 0, 0, 0, 0, 0, 0, 0},
        {&core2_cost, 0, 0, 16, 7, 16, 7, 16},
        {&generic32_cost, 0, 0, 16, 7, 16, 7, 16},
!       {&generic64_cost, 0, 0, 16, 7, 16, 7, 16},
!       {&amdfam10_cost, 0, 0, 32, 7, 32, 7, 32}
      };
  
    static const char * const cpu_names[] = TARGET_CPU_DEFAULT_NAMES;
***************
*** 1598,1604 ****
  	  PTA_3DNOW = 32,
  	  PTA_3DNOW_A = 64,
  	  PTA_64BIT = 128,
! 	  PTA_SSSE3 = 256
  	} flags;
      }
    const processor_alias_table[] =
--- 1667,1677 ----
  	  PTA_3DNOW = 32,
  	  PTA_3DNOW_A = 64,
  	  PTA_64BIT = 128,
! 	  PTA_SSSE3 = 256,
! 	  /* PTA_CX16 = 512, */
! 	  PTA_POPCNT = 1024,
! 	  PTA_ABM = 2048,
!  	  PTA_SSE4A = 4096
  	} flags;
      }
    const processor_alias_table[] =
***************
*** 1663,1668 ****
--- 1736,1749 ----
  				      | PTA_SSE3 },
        {"athlon-fx", PROCESSOR_K8, PTA_MMX | PTA_PREFETCH_SSE | PTA_3DNOW | PTA_64BIT
  				      | PTA_3DNOW_A | PTA_SSE | PTA_SSE2},
+       {"amdfam10", PROCESSOR_AMDFAM10, PTA_MMX | PTA_PREFETCH_SSE | PTA_3DNOW
+                                        | PTA_64BIT | PTA_3DNOW_A | PTA_SSE
+                                        | PTA_SSE2 | PTA_SSE3 | PTA_POPCNT
+                                        | PTA_ABM | PTA_SSE4A /*| PTA_CX16*/},
+       {"barcelona", PROCESSOR_AMDFAM10, PTA_MMX | PTA_PREFETCH_SSE | PTA_3DNOW
+                                        | PTA_64BIT | PTA_3DNOW_A | PTA_SSE
+                                        | PTA_SSE2 | PTA_SSE3 | PTA_POPCNT
+                                        | PTA_ABM | PTA_SSE4A /*| PTA_CX16*/},
        {"generic32", PROCESSOR_GENERIC32, 0 /* flags are only used for -march switch.  */ },
        {"generic64", PROCESSOR_GENERIC64, PTA_64BIT /* flags are only used for -march switch.  */ },
      };
***************
*** 1825,1830 ****
--- 1906,1922 ----
  	  target_flags |= MASK_SSSE3;
  	if (processor_alias_table[i].flags & PTA_PREFETCH_SSE)
  	  x86_prefetch_sse = true;
+  	/* if (processor_alias_table[i].flags & PTA_CX16)
+  	  x86_cmpxchg16b = true; */
+ 	if (processor_alias_table[i].flags & PTA_POPCNT
+ 	    && !(target_flags_explicit & MASK_POPCNT))
+ 	  target_flags |= MASK_POPCNT;
+ 	if (processor_alias_table[i].flags & PTA_ABM
+ 	    && !(target_flags_explicit & MASK_ABM))
+ 	  target_flags |= MASK_ABM;
+ 	if (processor_alias_table[i].flags & PTA_SSE4A
+ 	    && !(target_flags_explicit & MASK_SSE4A))
+ 	  target_flags |= MASK_SSE4A;
  	if (TARGET_64BIT && !(processor_alias_table[i].flags & PTA_64BIT))
  	  error ("CPU you selected does not support x86-64 "
  		 "instruction set");
***************
*** 2003,2008 ****
--- 2095,2104 ----
    if (TARGET_SSSE3)
      target_flags |= MASK_SSE3;
  
+   /* Turn on SSE3 builtins for -msse4a.  */
+   if (TARGET_SSE4A)
+     target_flags |= MASK_SSE3;
+ 
    /* Turn on SSE2 builtins for -msse3.  */
    if (TARGET_SSE3)
      target_flags |= MASK_SSE2;
***************
*** 2022,2027 ****
--- 2118,2127 ----
    if (TARGET_3DNOW)
      target_flags |= MASK_MMX;
  
+   /* Turn on POPCNT builtins for -mabm.  */
+   if (TARGET_ABM)
+     target_flags |= MASK_POPCNT;
+ 
    if (TARGET_64BIT)
      {
        if (TARGET_ALIGN_DOUBLE)
***************
*** 9247,9254 ****
  	}
  
        if (TARGET_SSE2 && mode == V2DFmode)
! 	{
! 	  rtx zero;
  
  	  /* When SSE registers are split into halves, we can avoid
  	     writing to the top half twice.  */
--- 9347,9362 ----
  	}
  
        if (TARGET_SSE2 && mode == V2DFmode)
!         {
!           rtx zero;
! 
!           if (TARGET_SSE_UNALIGNED_MOVE_OPTIMAL)
!             {
!               op0 = gen_lowpart (V2DFmode, op0);
!               op1 = gen_lowpart (V2DFmode, op1);
!               emit_insn (gen_sse2_movupd (op0, op1));
!               return;
!             }
  
  	  /* When SSE registers are split into halves, we can avoid
  	     writing to the top half twice.  */
***************
*** 9276,9282 ****
  	  emit_insn (gen_sse2_loadhpd (op0, op0, m));
  	}
        else
! 	{
  	  if (TARGET_SSE_PARTIAL_REG_DEPENDENCY)
  	    emit_move_insn (op0, CONST0_RTX (mode));
  	  else
--- 9384,9398 ----
  	  emit_insn (gen_sse2_loadhpd (op0, op0, m));
  	}
        else
!         {
!           if (TARGET_SSE_UNALIGNED_MOVE_OPTIMAL)
!             {
!               op0 = gen_lowpart (V4SFmode, op0);
!               op1 = gen_lowpart (V4SFmode, op1);
!               emit_insn (gen_sse_movups (op0, op1));
!               return;
!             }
! 
  	  if (TARGET_SSE_PARTIAL_REG_DEPENDENCY)
  	    emit_move_insn (op0, CONST0_RTX (mode));
  	  else
***************
*** 13833,13838 ****
--- 13949,13955 ----
      case PROCESSOR_PENTIUM4:
      case PROCESSOR_ATHLON:
      case PROCESSOR_K8:
+     case PROCESSOR_AMDFAM10:
      case PROCESSOR_NOCONA:
      case PROCESSOR_GENERIC32:
      case PROCESSOR_GENERIC64:
***************
*** 14031,14036 ****
--- 14148,14154 ----
  
      case PROCESSOR_ATHLON:
      case PROCESSOR_K8:
+     case PROCESSOR_AMDFAM10:
      case PROCESSOR_GENERIC32:
      case PROCESSOR_GENERIC64:
        memory = get_attr_memory (insn);
***************
*** 14744,14749 ****
--- 14862,14875 ----
    IX86_BUILTIN_PABSW128,
    IX86_BUILTIN_PABSD128,
  
+   /* AMDFAM10 - SSE4A New Instructions.  */
+   IX86_BUILTIN_MOVNTSD,
+   IX86_BUILTIN_MOVNTSS,
+   IX86_BUILTIN_EXTRQI,
+   IX86_BUILTIN_EXTRQ,
+   IX86_BUILTIN_INSERTQI,
+   IX86_BUILTIN_INSERTQ,
+ 
    IX86_BUILTIN_VEC_INIT_V2SI,
    IX86_BUILTIN_VEC_INIT_V4HI,
    IX86_BUILTIN_VEC_INIT_V8QI,
***************
*** 15468,15473 ****
--- 15594,15611 ----
      = build_function_type_list (void_type_node,
  			        pchar_type_node, V16QI_type_node, NULL_TREE);
  
+   tree v2di_ftype_v2di_unsigned_unsigned
+     = build_function_type_list (V2DI_type_node, V2DI_type_node,
+                                 unsigned_type_node, unsigned_type_node,
+                                 NULL_TREE);
+   tree v2di_ftype_v2di_v2di_unsigned_unsigned
+     = build_function_type_list (V2DI_type_node, V2DI_type_node, V2DI_type_node,
+                                 unsigned_type_node, unsigned_type_node,
+                                 NULL_TREE);
+   tree v2di_ftype_v2di_v16qi
+     = build_function_type_list (V2DI_type_node, V2DI_type_node, V16QI_type_node,
+                                 NULL_TREE);
+ 
    tree float80_type;
    tree float128_type;
    tree ftype;
***************
*** 15804,15809 ****
--- 15942,15961 ----
    def_builtin (MASK_SSSE3, "__builtin_ia32_palignr", di_ftype_di_di_int,
  	       IX86_BUILTIN_PALIGNR);
  
+   /* AMDFAM10 SSE4A New built-ins  */
+   def_builtin (MASK_SSE4A, "__builtin_ia32_movntsd", 
+                void_ftype_pdouble_v2df, IX86_BUILTIN_MOVNTSD);
+   def_builtin (MASK_SSE4A, "__builtin_ia32_movntss", 
+                void_ftype_pfloat_v4sf, IX86_BUILTIN_MOVNTSS);
+   def_builtin (MASK_SSE4A, "__builtin_ia32_extrqi", 
+                v2di_ftype_v2di_unsigned_unsigned, IX86_BUILTIN_EXTRQI);
+   def_builtin (MASK_SSE4A, "__builtin_ia32_extrq",
+                v2di_ftype_v2di_v16qi,  IX86_BUILTIN_EXTRQ);
+   def_builtin (MASK_SSE4A, "__builtin_ia32_insertqi",
+                v2di_ftype_v2di_v2di_unsigned_unsigned, IX86_BUILTIN_INSERTQI);
+   def_builtin (MASK_SSE4A, "__builtin_ia32_insertq",
+                v2di_ftype_v2di_v2di, IX86_BUILTIN_INSERTQ);
+ 
    /* Access to the vec_init patterns.  */
    ftype = build_function_type_list (V2SI_type_node, integer_type_node,
  				    integer_type_node, NULL_TREE);
***************
*** 16300,16308 ****
    enum insn_code icode;
    tree fndecl = TREE_OPERAND (TREE_OPERAND (exp, 0), 0);
    tree arglist = TREE_OPERAND (exp, 1);
!   tree arg0, arg1, arg2;
!   rtx op0, op1, op2, pat;
!   enum machine_mode tmode, mode0, mode1, mode2, mode3;
    unsigned int fcode = DECL_FUNCTION_CODE (fndecl);
  
    switch (fcode)
--- 16452,16460 ----
    enum insn_code icode;
    tree fndecl = TREE_OPERAND (TREE_OPERAND (exp, 0), 0);
    tree arglist = TREE_OPERAND (exp, 1);
!   tree arg0, arg1, arg2, arg3;
!   rtx op0, op1, op2, op3, pat;
!   enum machine_mode tmode, mode0, mode1, mode2, mode3, mode4;
    unsigned int fcode = DECL_FUNCTION_CODE (fndecl);
  
    switch (fcode)
***************
*** 16818,16823 ****
--- 16970,17083 ----
        emit_insn (pat);
        return target;
  
+     case IX86_BUILTIN_MOVNTSD:
+       return ix86_expand_store_builtin (CODE_FOR_sse4a_vmmovntv2df, arglist);
+ 
+     case IX86_BUILTIN_MOVNTSS:
+       return ix86_expand_store_builtin (CODE_FOR_sse4a_vmmovntv4sf, arglist);
+ 
+     case IX86_BUILTIN_INSERTQ:
+     case IX86_BUILTIN_EXTRQ:
+       icode = (fcode == IX86_BUILTIN_EXTRQ
+                ? CODE_FOR_sse4a_extrq
+                : CODE_FOR_sse4a_insertq);
+       arg0 = TREE_VALUE (arglist);
+       arg1 = TREE_VALUE (TREE_CHAIN (arglist));
+       op0 = expand_normal (arg0);
+       op1 = expand_normal (arg1);
+       tmode = insn_data[icode].operand[0].mode;
+       mode1 = insn_data[icode].operand[1].mode;
+       mode2 = insn_data[icode].operand[2].mode;
+       if (! (*insn_data[icode].operand[1].predicate) (op0, mode1))
+         op0 = copy_to_mode_reg (mode1, op0);
+       if (! (*insn_data[icode].operand[2].predicate) (op1, mode2))
+         op1 = copy_to_mode_reg (mode2, op1);
+       if (optimize || target == 0
+           || GET_MODE (target) != tmode
+           || ! (*insn_data[icode].operand[0].predicate) (target, tmode))
+         target = gen_reg_rtx (tmode);
+       pat = GEN_FCN (icode) (target, op0, op1);
+       if (! pat)
+         return NULL_RTX;
+       emit_insn (pat);
+       return target;
+ 
+     case IX86_BUILTIN_EXTRQI:
+       icode = CODE_FOR_sse4a_extrqi;
+       arg0 = TREE_VALUE (arglist);
+       arg1 = TREE_VALUE (TREE_CHAIN (arglist));
+       arg2 = TREE_VALUE (TREE_CHAIN (TREE_CHAIN (arglist)));
+       op0 = expand_normal (arg0);
+       op1 = expand_normal (arg1);
+       op2 = expand_normal (arg2);
+       tmode = insn_data[icode].operand[0].mode;
+       mode1 = insn_data[icode].operand[1].mode;
+       mode2 = insn_data[icode].operand[2].mode;
+       mode3 = insn_data[icode].operand[3].mode;
+       if (! (*insn_data[icode].operand[1].predicate) (op0, mode1))
+         op0 = copy_to_mode_reg (mode1, op0);
+       if (! (*insn_data[icode].operand[2].predicate) (op1, mode2))
+         {
+           error ("index mask must be an immediate");
+           return gen_reg_rtx (tmode);
+         }
+       if (! (*insn_data[icode].operand[3].predicate) (op2, mode3))
+         {
+           error ("length mask must be an immediate");
+           return gen_reg_rtx (tmode);
+         }
+       if (optimize || target == 0
+           || GET_MODE (target) != tmode
+           || ! (*insn_data[icode].operand[0].predicate) (target, tmode))
+         target = gen_reg_rtx (tmode);
+       pat = GEN_FCN (icode) (target, op0, op1, op2);
+       if (! pat)
+         return NULL_RTX;
+       emit_insn (pat);
+       return target;
+ 
+     case IX86_BUILTIN_INSERTQI:
+       icode = CODE_FOR_sse4a_insertqi;
+       arg0 = TREE_VALUE (arglist);
+       arg1 = TREE_VALUE (TREE_CHAIN (arglist));
+       arg2 = TREE_VALUE (TREE_CHAIN (TREE_CHAIN (arglist)));
+       arg3 = TREE_VALUE (TREE_CHAIN (TREE_CHAIN (TREE_CHAIN (arglist))));
+       op0 = expand_normal (arg0);
+       op1 = expand_normal (arg1);
+       op2 = expand_normal (arg2);
+       op3 = expand_normal (arg3);
+       tmode = insn_data[icode].operand[0].mode;
+       mode1 = insn_data[icode].operand[1].mode;
+       mode2 = insn_data[icode].operand[2].mode;
+       mode3 = insn_data[icode].operand[3].mode;
+       mode4 = insn_data[icode].operand[4].mode;
+ 
+       if (! (*insn_data[icode].operand[1].predicate) (op0, mode1))
+         op0 = copy_to_mode_reg (mode1, op0);
+ 
+       if (! (*insn_data[icode].operand[2].predicate) (op1, mode2))
+         op1 = copy_to_mode_reg (mode2, op1);
+ 
+       if (! (*insn_data[icode].operand[3].predicate) (op2, mode3))
+         {
+           error ("index mask must be an immediate");
+           return gen_reg_rtx (tmode);
+         }
+       if (! (*insn_data[icode].operand[4].predicate) (op3, mode4))
+         {
+           error ("length mask must be an immediate");
+           return gen_reg_rtx (tmode);
+         }
+       if (optimize || target == 0
+           || GET_MODE (target) != tmode
+           || ! (*insn_data[icode].operand[0].predicate) (target, tmode))
+         target = gen_reg_rtx (tmode);
+       pat = GEN_FCN (icode) (target, op0, op1, op2, op3);
+       if (! pat)
+         return NULL_RTX;
+       emit_insn (pat);
+       return target;
+ 
      case IX86_BUILTIN_VEC_INIT_V2SI:
      case IX86_BUILTIN_VEC_INIT_V4HI:
      case IX86_BUILTIN_VEC_INIT_V8QI:
*** ../gcc.orig/./config/i386/i386.md	2011-05-12 12:34:22.000000000 +0300
--- ./config/i386/i386.md	2011-11-15 08:49:22.000000000 +0200
***************
*** 153,158 ****
--- 153,164 ----
     (UNSPEC_PSHUFB		120)
     (UNSPEC_PSIGN		121)
     (UNSPEC_PALIGNR		122)
+ 
+    ; For SSE4A support
+    (UNSPEC_EXTRQI               130)
+    (UNSPEC_EXTRQ                131)   
+    (UNSPEC_INSERTQI             132)
+    (UNSPEC_INSERTQ              133)
    ])
  
  (define_constants
***************
*** 192,198 ****
  
  ;; Processor type.  This attribute must exactly match the processor_type
  ;; enumeration in i386.h.
! (define_attr "cpu" "i386,i486,pentium,pentiumpro,geode,k6,athlon,pentium4,k8,nocona,core2,generic32,generic64"
    (const (symbol_ref "ix86_tune")))
  
  ;; A basic instruction type.  Refinements due to arguments to be
--- 198,204 ----
  
  ;; Processor type.  This attribute must exactly match the processor_type
  ;; enumeration in i386.h.
! (define_attr "cpu" "i386,i486,pentium,pentiumpro,geode,k6,athlon,pentium4,k8,nocona,core2,generic32,generic64,amdfam10"
    (const (symbol_ref "ix86_tune")))
  
  ;; A basic instruction type.  Refinements due to arguments to be
***************
*** 203,212 ****
     incdec,ishift,ishift1,rotate,rotate1,imul,idiv,
     icmp,test,ibr,setcc,icmov,
     push,pop,call,callv,leave,
!    str,cld,
     fmov,fop,fsgn,fmul,fdiv,fpspc,fcmov,fcmp,fxch,fistp,fisttp,frndint,
     sselog,sselog1,sseiadd,sseishft,sseimul,
!    sse,ssemov,sseadd,ssemul,ssecmp,ssecomi,ssecvt,sseicvt,ssediv,
     mmx,mmxmov,mmxadd,mmxmul,mmxcmp,mmxcvt,mmxshft"
    (const_string "other"))
  
--- 209,218 ----
     incdec,ishift,ishift1,rotate,rotate1,imul,idiv,
     icmp,test,ibr,setcc,icmov,
     push,pop,call,callv,leave,
!    str,bitmanip,cld,
     fmov,fop,fsgn,fmul,fdiv,fpspc,fcmov,fcmp,fxch,fistp,fisttp,frndint,
     sselog,sselog1,sseiadd,sseishft,sseimul,
!    sse,ssemov,sseadd,ssemul,ssecmp,ssecomi,ssecvt,sseicvt,ssediv,sseins,
     mmx,mmxmov,mmxadd,mmxmul,mmxcmp,mmxcvt,mmxshft"
    (const_string "other"))
  
***************
*** 220,226 ****
    (cond [(eq_attr "type" "fmov,fop,fsgn,fmul,fdiv,fpspc,fcmov,fcmp,fxch,fistp,fisttp,frndint")
  	   (const_string "i387")
  	 (eq_attr "type" "sselog,sselog1,sseiadd,sseishft,sseimul,
! 			  sse,ssemov,sseadd,ssemul,ssecmp,ssecomi,ssecvt,sseicvt,ssediv")
  	   (const_string "sse")
  	 (eq_attr "type" "mmx,mmxmov,mmxadd,mmxmul,mmxcmp,mmxcvt,mmxshft")
  	   (const_string "mmx")
--- 226,232 ----
    (cond [(eq_attr "type" "fmov,fop,fsgn,fmul,fdiv,fpspc,fcmov,fcmp,fxch,fistp,fisttp,frndint")
  	   (const_string "i387")
  	 (eq_attr "type" "sselog,sselog1,sseiadd,sseishft,sseimul,
! 			  sse,ssemov,sseadd,ssemul,ssecmp,ssecomi,ssecvt,sseicvt,ssediv,sseins")
  	   (const_string "sse")
  	 (eq_attr "type" "mmx,mmxmov,mmxadd,mmxmul,mmxcmp,mmxcvt,mmxshft")
  	   (const_string "mmx")
***************
*** 230,236 ****
  
  ;; The (bounding maximum) length of an instruction immediate.
  (define_attr "length_immediate" ""
!   (cond [(eq_attr "type" "incdec,setcc,icmov,str,cld,lea,other,multi,idiv,leave")
  	   (const_int 0)
  	 (eq_attr "unit" "i387,sse,mmx")
  	   (const_int 0)
--- 236,243 ----
  
  ;; The (bounding maximum) length of an instruction immediate.
  (define_attr "length_immediate" ""
!   (cond [(eq_attr "type" "incdec,setcc,icmov,str,cld,lea,other,multi,idiv,leave,
!                           bitmanip")
  	   (const_int 0)
  	 (eq_attr "unit" "i387,sse,mmx")
  	   (const_int 0)
***************
*** 284,290 ****
  ;; Set when 0f opcode prefix is used.
  (define_attr "prefix_0f" ""
    (if_then_else 
!     (ior (eq_attr "type" "imovx,setcc,icmov")
  	 (eq_attr "unit" "sse,mmx"))
      (const_int 1)
      (const_int 0)))
--- 291,297 ----
  ;; Set when 0f opcode prefix is used.
  (define_attr "prefix_0f" ""
    (if_then_else 
!     (ior (eq_attr "type" "imovx,setcc,icmov,bitmanip")
  	 (eq_attr "unit" "sse,mmx"))
      (const_int 1)
      (const_int 0)))
***************
*** 413,419 ****
  	   (const_string "load")
  	 (and (eq_attr "type"
  		 "!alu1,negnot,ishift1,
! 		   imov,imovx,icmp,test,
  		   fmov,fcmp,fsgn,
  		   sse,ssemov,ssecmp,ssecomi,ssecvt,sseicvt,sselog1,
  		   mmx,mmxmov,mmxcmp,mmxcvt")
--- 420,426 ----
  	   (const_string "load")
  	 (and (eq_attr "type"
  		 "!alu1,negnot,ishift1,
! 		   imov,imovx,icmp,test,bitmanip,
  		   fmov,fcmp,fsgn,
  		   sse,ssemov,ssecmp,ssecomi,ssecvt,sseicvt,sselog1,
  		   mmx,mmxmov,mmxcmp,mmxcvt")
***************
*** 968,977 ****
    "sahf"
    [(set_attr "length" "1")
     (set_attr "athlon_decode" "vector")
     (set_attr "mode" "SI")])
  
  ;; Pentium Pro can do steps 1 through 3 in one go.
! 
  (define_insn "*cmpfp_i_mixed"
    [(set (reg:CCFP FLAGS_REG)
  	(compare:CCFP (match_operand 0 "register_operand" "f,x")
--- 975,985 ----
    "sahf"
    [(set_attr "length" "1")
     (set_attr "athlon_decode" "vector")
+    (set_attr "amdfam10_decode" "direct")
     (set_attr "mode" "SI")])
  
  ;; Pentium Pro can do steps 1 through 3 in one go.
! ;; comi*, ucomi*, fcomi*, ficomi*,fucomi* (i387 instructions set condition codes) 
  (define_insn "*cmpfp_i_mixed"
    [(set (reg:CCFP FLAGS_REG)
  	(compare:CCFP (match_operand 0 "register_operand" "f,x")
***************
*** 985,991 ****
       (if_then_else (match_operand:SF 1 "" "")
          (const_string "SF")
          (const_string "DF")))
!    (set_attr "athlon_decode" "vector")])
  
  (define_insn "*cmpfp_i_sse"
    [(set (reg:CCFP FLAGS_REG)
--- 993,1000 ----
       (if_then_else (match_operand:SF 1 "" "")
          (const_string "SF")
          (const_string "DF")))
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "direct")])
  
  (define_insn "*cmpfp_i_sse"
    [(set (reg:CCFP FLAGS_REG)
***************
*** 1000,1006 ****
       (if_then_else (match_operand:SF 1 "" "")
          (const_string "SF")
          (const_string "DF")))
!    (set_attr "athlon_decode" "vector")])
  
  (define_insn "*cmpfp_i_i387"
    [(set (reg:CCFP FLAGS_REG)
--- 1009,1016 ----
       (if_then_else (match_operand:SF 1 "" "")
          (const_string "SF")
          (const_string "DF")))
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "direct")])
  
  (define_insn "*cmpfp_i_i387"
    [(set (reg:CCFP FLAGS_REG)
***************
*** 1019,1025 ****
  	      (const_string "DF")
  	   ]
  	   (const_string "XF")))
!    (set_attr "athlon_decode" "vector")])
  
  (define_insn "*cmpfp_iu_mixed"
    [(set (reg:CCFPU FLAGS_REG)
--- 1029,1036 ----
  	      (const_string "DF")
  	   ]
  	   (const_string "XF")))
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "direct")])
  
  (define_insn "*cmpfp_iu_mixed"
    [(set (reg:CCFPU FLAGS_REG)
***************
*** 1034,1040 ****
       (if_then_else (match_operand:SF 1 "" "")
          (const_string "SF")
          (const_string "DF")))
!    (set_attr "athlon_decode" "vector")])
  
  (define_insn "*cmpfp_iu_sse"
    [(set (reg:CCFPU FLAGS_REG)
--- 1045,1052 ----
       (if_then_else (match_operand:SF 1 "" "")
          (const_string "SF")
          (const_string "DF")))
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "direct")])
  
  (define_insn "*cmpfp_iu_sse"
    [(set (reg:CCFPU FLAGS_REG)
***************
*** 1049,1055 ****
       (if_then_else (match_operand:SF 1 "" "")
          (const_string "SF")
          (const_string "DF")))
!    (set_attr "athlon_decode" "vector")])
  
  (define_insn "*cmpfp_iu_387"
    [(set (reg:CCFPU FLAGS_REG)
--- 1061,1068 ----
       (if_then_else (match_operand:SF 1 "" "")
          (const_string "SF")
          (const_string "DF")))
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "direct")])
  
  (define_insn "*cmpfp_iu_387"
    [(set (reg:CCFPU FLAGS_REG)
***************
*** 1068,1074 ****
  	      (const_string "DF")
  	   ]
  	   (const_string "XF")))
!    (set_attr "athlon_decode" "vector")])
  
  ;; Move instructions.
  
--- 1081,1088 ----
  	      (const_string "DF")
  	   ]
  	   (const_string "XF")))
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "direct")])
  
  ;; Move instructions.
  
***************
*** 1274,1280 ****
    [(set_attr "type" "imov")
     (set_attr "mode" "SI")
     (set_attr "pent_pair" "np")
!    (set_attr "athlon_decode" "vector")])
  
  (define_expand "movhi"
    [(set (match_operand:HI 0 "nonimmediate_operand" "")
--- 1288,1295 ----
    [(set_attr "type" "imov")
     (set_attr "mode" "SI")
     (set_attr "pent_pair" "np")
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "double")])   
  
  (define_expand "movhi"
    [(set (match_operand:HI 0 "nonimmediate_operand" "")
***************
*** 1391,1398 ****
    [(set_attr "type" "imov")
     (set_attr "mode" "SI")
     (set_attr "pent_pair" "np")
!    (set_attr "athlon_decode" "vector")])
  
  (define_insn "*swaphi_2"
    [(set (match_operand:HI 0 "register_operand" "+r")
  	(match_operand:HI 1 "register_operand" "+r"))
--- 1406,1415 ----
    [(set_attr "type" "imov")
     (set_attr "mode" "SI")
     (set_attr "pent_pair" "np")
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "double")])   
  
+ ;; Not added amdfam10_decode since TARGET_PARTIAL_REG_STALL is disabled for AMDFAM10
  (define_insn "*swaphi_2"
    [(set (match_operand:HI 0 "register_operand" "+r")
  	(match_operand:HI 1 "register_operand" "+r"))
***************
*** 1565,1572 ****
    [(set_attr "type" "imov")
     (set_attr "mode" "SI")
     (set_attr "pent_pair" "np")
!    (set_attr "athlon_decode" "vector")])
  
  (define_insn "*swapqi_2"
    [(set (match_operand:QI 0 "register_operand" "+q")
  	(match_operand:QI 1 "register_operand" "+q"))
--- 1582,1591 ----
    [(set_attr "type" "imov")
     (set_attr "mode" "SI")
     (set_attr "pent_pair" "np")
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "vector")])   
  
+ ;; Not added amdfam10_decode since TARGET_PARTIAL_REG_STALL is disabled for AMDFAM10
  (define_insn "*swapqi_2"
    [(set (match_operand:QI 0 "register_operand" "+q")
  	(match_operand:QI 1 "register_operand" "+q"))
***************
*** 2120,2126 ****
    [(set_attr "type" "imov")
     (set_attr "mode" "DI")
     (set_attr "pent_pair" "np")
!    (set_attr "athlon_decode" "vector")])
  
  (define_expand "movti"
    [(set (match_operand:TI 0 "nonimmediate_operand" "")
--- 2139,2146 ----
    [(set_attr "type" "imov")
     (set_attr "mode" "DI")
     (set_attr "pent_pair" "np")
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "double")])   
  
  (define_expand "movti"
    [(set (match_operand:TI 0 "nonimmediate_operand" "")
***************
*** 4150,4156 ****
    "cvttss2si{q}\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "SF")
!    (set_attr "athlon_decode" "double,vector")])
  
  (define_insn "fix_truncdfdi_sse"
    [(set (match_operand:DI 0 "register_operand" "=r,r")
--- 4170,4177 ----
    "cvttss2si{q}\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "SF")
!    (set_attr "athlon_decode" "double,vector")
!    (set_attr "amdfam10_decode" "double,double")])
  
  (define_insn "fix_truncdfdi_sse"
    [(set (match_operand:DI 0 "register_operand" "=r,r")
***************
*** 4159,4165 ****
    "cvttsd2si{q}\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "double,vector")])
  
  (define_insn "fix_truncsfsi_sse"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
--- 4180,4187 ----
    "cvttsd2si{q}\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "double,vector")
!    (set_attr "amdfam10_decode" "double,double")])
  
  (define_insn "fix_truncsfsi_sse"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
***************
*** 4168,4174 ****
    "cvttss2si\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "double,vector")])
  
  (define_insn "fix_truncdfsi_sse"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
--- 4190,4197 ----
    "cvttss2si\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "double,vector")
!    (set_attr "amdfam10_decode" "double,double")])
  
  (define_insn "fix_truncdfsi_sse"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
***************
*** 4177,4183 ****
    "cvttsd2si\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "double,vector")])
  
  ;; Avoid vector decoded forms of the instruction.
  (define_peephole2
--- 4200,4207 ----
    "cvttsd2si\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "double,vector")
!    (set_attr "amdfam10_decode" "double,double")])
  
  ;; Avoid vector decoded forms of the instruction.
  (define_peephole2
***************
*** 4438,4444 ****
    [(set_attr "length" "2")
     (set_attr "mode" "HI")
     (set_attr "unit" "i387")
!    (set_attr "athlon_decode" "vector")])
  
  ;; Conversion between fixed point and floating point.
  
--- 4462,4469 ----
    [(set_attr "length" "2")
     (set_attr "mode" "HI")
     (set_attr "unit" "i387")
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "vector")])   
  
  ;; Conversion between fixed point and floating point.
  
***************
*** 4489,4494 ****
--- 4514,4520 ----
     (set_attr "mode" "SF")
     (set_attr "unit" "*,i387,*,*")
     (set_attr "athlon_decode" "*,*,vector,double")
+    (set_attr "amdfam10_decode" "*,*,vector,double")
     (set_attr "fp_int_src" "true")])
  
  (define_insn "*floatsisf2_sse"
***************
*** 4499,4504 ****
--- 4525,4531 ----
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "SF")
     (set_attr "athlon_decode" "vector,double")
+    (set_attr "amdfam10_decode" "vector,double")
     (set_attr "fp_int_src" "true")])
  
  (define_insn "*floatsisf2_i387"
***************
*** 4532,4537 ****
--- 4559,4565 ----
     (set_attr "mode" "SF")
     (set_attr "unit" "*,i387,*,*")
     (set_attr "athlon_decode" "*,*,vector,double")
+    (set_attr "amdfam10_decode" "*,*,vector,double")
     (set_attr "fp_int_src" "true")])
  
  (define_insn "*floatdisf2_sse"
***************
*** 4542,4547 ****
--- 4570,4576 ----
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "SF")
     (set_attr "athlon_decode" "vector,double")
+    (set_attr "amdfam10_decode" "vector,double")
     (set_attr "fp_int_src" "true")])
  
  (define_insn "*floatdisf2_i387"
***************
*** 4600,4605 ****
--- 4629,4635 ----
     (set_attr "mode" "DF")
     (set_attr "unit" "*,i387,*,*")
     (set_attr "athlon_decode" "*,*,double,direct")
+    (set_attr "amdfam10_decode" "*,*,vector,double")
     (set_attr "fp_int_src" "true")])
  
  (define_insn "*floatsidf2_sse"
***************
*** 4610,4615 ****
--- 4640,4646 ----
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
     (set_attr "athlon_decode" "double,direct")
+    (set_attr "amdfam10_decode" "vector,double")
     (set_attr "fp_int_src" "true")])
  
  (define_insn "*floatsidf2_i387"
***************
*** 4643,4648 ****
--- 4674,4680 ----
     (set_attr "mode" "DF")
     (set_attr "unit" "*,i387,*,*")
     (set_attr "athlon_decode" "*,*,double,direct")
+    (set_attr "amdfam10_decode" "*,*,vector,double")
     (set_attr "fp_int_src" "true")])
  
  (define_insn "*floatdidf2_sse"
***************
*** 4653,4658 ****
--- 4685,4691 ----
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
     (set_attr "athlon_decode" "double,direct")
+    (set_attr "amdfam10_decode" "vector,double")
     (set_attr "fp_int_src" "true")])
  
  (define_insn "*floatdidf2_i387"
***************
*** 6860,6865 ****
--- 6893,6906 ----
    "TARGET_64BIT"
    "")
  
+ ;; On AMDFAM10 
+ ;; IMUL reg64, reg64, imm8 	Direct
+ ;; IMUL reg64, mem64, imm8 	VectorPath
+ ;; IMUL reg64, reg64, imm32 	Direct
+ ;; IMUL reg64, mem64, imm32 	VectorPath 
+ ;; IMUL reg64, reg64 		Direct
+ ;; IMUL reg64, mem64 		Direct
+ 
  (define_insn "*muldi3_1_rex64"
    [(set (match_operand:DI 0 "register_operand" "=r,r,r")
  	(mult:DI (match_operand:DI 1 "nonimmediate_operand" "%rm,rm,0")
***************
*** 6882,6887 ****
--- 6923,6933 ----
  		    (match_operand 1 "memory_operand" ""))
  		  (const_string "vector")]
  	      (const_string "direct")))
+    (set (attr "amdfam10_decode")
+ 	(cond [(and (eq_attr "alternative" "0,1")
+ 		    (match_operand 1 "memory_operand" ""))
+ 		  (const_string "vector")]
+ 	      (const_string "direct")))	      
     (set_attr "mode" "DI")])
  
  (define_expand "mulsi3"
***************
*** 6892,6897 ****
--- 6938,6951 ----
    ""
    "")
  
+ ;; On AMDFAM10 
+ ;; IMUL reg32, reg32, imm8 	Direct
+ ;; IMUL reg32, mem32, imm8 	VectorPath
+ ;; IMUL reg32, reg32, imm32 	Direct
+ ;; IMUL reg32, mem32, imm32 	VectorPath
+ ;; IMUL reg32, reg32 		Direct
+ ;; IMUL reg32, mem32 		Direct
+ 
  (define_insn "*mulsi3_1"
    [(set (match_operand:SI 0 "register_operand" "=r,r,r")
  	(mult:SI (match_operand:SI 1 "nonimmediate_operand" "%rm,rm,0")
***************
*** 6913,6918 ****
--- 6967,6977 ----
  		    (match_operand 1 "memory_operand" ""))
  		  (const_string "vector")]
  	      (const_string "direct")))
+    (set (attr "amdfam10_decode")
+ 	(cond [(and (eq_attr "alternative" "0,1")
+ 		    (match_operand 1 "memory_operand" ""))
+ 		  (const_string "vector")]
+ 	      (const_string "direct")))	      
     (set_attr "mode" "SI")])
  
  (define_insn "*mulsi3_1_zext"
***************
*** 6938,6943 ****
--- 6997,7007 ----
  		    (match_operand 1 "memory_operand" ""))
  		  (const_string "vector")]
  	      (const_string "direct")))
+    (set (attr "amdfam10_decode")
+ 	(cond [(and (eq_attr "alternative" "0,1")
+ 		    (match_operand 1 "memory_operand" ""))
+ 		  (const_string "vector")]
+ 	      (const_string "direct")))	      
     (set_attr "mode" "SI")])
  
  (define_expand "mulhi3"
***************
*** 6948,6953 ****
--- 7012,7024 ----
    "TARGET_HIMODE_MATH"
    "")
  
+ ;; On AMDFAM10
+ ;; IMUL reg16, reg16, imm8 	VectorPath
+ ;; IMUL reg16, mem16, imm8 	VectorPath
+ ;; IMUL reg16, reg16, imm16 	VectorPath
+ ;; IMUL reg16, mem16, imm16 	VectorPath
+ ;; IMUL reg16, reg16 		Direct
+ ;; IMUL reg16, mem16 		Direct
  (define_insn "*mulhi3_1"
    [(set (match_operand:HI 0 "register_operand" "=r,r,r")
  	(mult:HI (match_operand:HI 1 "nonimmediate_operand" "%rm,rm,0")
***************
*** 6966,6971 ****
--- 7037,7046 ----
  	       (eq_attr "alternative" "1,2")
  		  (const_string "vector")]
  	      (const_string "direct")))
+    (set (attr "amdfam10_decode")
+ 	(cond [(eq_attr "alternative" "0,1")
+ 		  (const_string "vector")]
+ 	      (const_string "direct")))
     (set_attr "mode" "HI")])
  
  (define_expand "mulqi3"
***************
*** 6976,6981 ****
--- 7051,7060 ----
    "TARGET_QIMODE_MATH"
    "")
  
+ ;;On AMDFAM10
+ ;; MUL reg8 	Direct
+ ;; MUL mem8 	Direct
+ 
  (define_insn "*mulqi3_1"
    [(set (match_operand:QI 0 "register_operand" "=a")
  	(mult:QI (match_operand:QI 1 "nonimmediate_operand" "%0")
***************
*** 6990,6995 ****
--- 7069,7075 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "direct")))
+    (set_attr "amdfam10_decode" "direct")        
     (set_attr "mode" "QI")])
  
  (define_expand "umulqihi3"
***************
*** 7016,7021 ****
--- 7096,7102 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "direct")))
+    (set_attr "amdfam10_decode" "direct")        
     (set_attr "mode" "QI")])
  
  (define_expand "mulqihi3"
***************
*** 7040,7045 ****
--- 7121,7127 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "direct")))
+    (set_attr "amdfam10_decode" "direct")        
     (set_attr "mode" "QI")])
  
  (define_expand "umulditi3"
***************
*** 7066,7071 ****
--- 7148,7154 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "double")))
+    (set_attr "amdfam10_decode" "double")        
     (set_attr "mode" "DI")])
  
  ;; We can't use this pattern in 64bit mode, since it results in two separate 32bit registers
***************
*** 7093,7098 ****
--- 7176,7182 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "double")))
+    (set_attr "amdfam10_decode" "double")        
     (set_attr "mode" "SI")])
  
  (define_expand "mulditi3"
***************
*** 7119,7124 ****
--- 7203,7209 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "double")))
+    (set_attr "amdfam10_decode" "double")
     (set_attr "mode" "DI")])
  
  (define_expand "mulsidi3"
***************
*** 7145,7150 ****
--- 7230,7236 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "double")))
+    (set_attr "amdfam10_decode" "double")        
     (set_attr "mode" "SI")])
  
  (define_expand "umuldi3_highpart"
***************
*** 7181,7186 ****
--- 7267,7273 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "double")))
+    (set_attr "amdfam10_decode" "double")        
     (set_attr "mode" "DI")])
  
  (define_expand "umulsi3_highpart"
***************
*** 7216,7221 ****
--- 7303,7309 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "double")))
+    (set_attr "amdfam10_decode" "double")
     (set_attr "mode" "SI")])
  
  (define_insn "*umulsi3_highpart_zext"
***************
*** 7238,7243 ****
--- 7326,7332 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "double")))
+    (set_attr "amdfam10_decode" "double")
     (set_attr "mode" "SI")])
  
  (define_expand "smuldi3_highpart"
***************
*** 7273,7278 ****
--- 7362,7368 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "double")))
+    (set_attr "amdfam10_decode" "double")
     (set_attr "mode" "DI")])
  
  (define_expand "smulsi3_highpart"
***************
*** 7307,7312 ****
--- 7397,7403 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "double")))
+    (set_attr "amdfam10_decode" "double")
     (set_attr "mode" "SI")])
  
  (define_insn "*smulsi3_highpart_zext"
***************
*** 7328,7333 ****
--- 7419,7425 ----
       (if_then_else (eq_attr "cpu" "athlon")
          (const_string "vector")
          (const_string "double")))
+    (set_attr "amdfam10_decode" "double")
     (set_attr "mode" "SI")])
  
  ;; The patterns that match these are at the end of this file.
***************
*** 10309,10315 ****
    [(set_attr "type" "ishift")
     (set_attr "prefix_0f" "1")
     (set_attr "mode" "DI")
!    (set_attr "athlon_decode" "vector")])
  
  (define_expand "x86_64_shift_adj"
    [(set (reg:CCZ FLAGS_REG)
--- 10401,10408 ----
    [(set_attr "type" "ishift")
     (set_attr "prefix_0f" "1")
     (set_attr "mode" "DI")
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "vector")])   
  
  (define_expand "x86_64_shift_adj"
    [(set (reg:CCZ FLAGS_REG)
***************
*** 10524,10530 ****
     (set_attr "prefix_0f" "1")
     (set_attr "mode" "SI")
     (set_attr "pent_pair" "np")
!    (set_attr "athlon_decode" "vector")])
  
  (define_expand "x86_shift_adj_1"
    [(set (reg:CCZ FLAGS_REG)
--- 10617,10624 ----
     (set_attr "prefix_0f" "1")
     (set_attr "mode" "SI")
     (set_attr "pent_pair" "np")
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "vector")])   
  
  (define_expand "x86_shift_adj_1"
    [(set (reg:CCZ FLAGS_REG)
***************
*** 11284,11290 ****
    [(set_attr "type" "ishift")
     (set_attr "prefix_0f" "1")
     (set_attr "mode" "DI")
!    (set_attr "athlon_decode" "vector")])
  
  (define_expand "ashrdi3"
    [(set (match_operand:DI 0 "shiftdi_operand" "")
--- 11378,11385 ----
    [(set_attr "type" "ishift")
     (set_attr "prefix_0f" "1")
     (set_attr "mode" "DI")
!    (set_attr "athlon_decode" "vector")
!    (set_attr "amdfam10_decode" "vector")])   
  
  (define_expand "ashrdi3"
    [(set (match_operand:DI 0 "shiftdi_operand" "")
***************
*** 14558,14564 ****
       [(set (match_dup 0) (xor:SI (match_dup 0) (const_int 31)))
        (clobber (reg:CC FLAGS_REG))])]
    ""
!   "")
  
  (define_insn "*bsr"
    [(set (match_operand:SI 0 "register_operand" "=r")
--- 14653,14675 ----
       [(set (match_dup 0) (xor:SI (match_dup 0) (const_int 31)))
        (clobber (reg:CC FLAGS_REG))])]
    ""
! {
!   if (TARGET_ABM)
!     {
!       emit_insn (gen_clzsi2_abm (operands[0], operands[1]));
!       DONE;
!     }
! })
! 
! (define_insn "clzsi2_abm"
!   [(set (match_operand:SI 0 "register_operand" "=r")
!         (clz:SI (match_operand:SI 1 "nonimmediate_operand" "")))
!    (clobber (reg:CC FLAGS_REG))]
!   "TARGET_ABM"
!   "lzcnt{l}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_rep" "1")
!    (set_attr "type" "bitmanip")
!    (set_attr "mode" "SI")])
  
  (define_insn "*bsr"
    [(set (match_operand:SI 0 "register_operand" "=r")
***************
*** 14567,14573 ****
     (clobber (reg:CC FLAGS_REG))]
    ""
    "bsr{l}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_0f" "1")])
  
  (define_expand "clzdi2"
    [(parallel
--- 14678,14721 ----
     (clobber (reg:CC FLAGS_REG))]
    ""
    "bsr{l}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_0f" "1")
!    (set_attr "mode" "SI")])
! 
! (define_insn "popcountsi2"
!   [(set (match_operand:SI 0 "register_operand" "=r")
! 	(popcount:SI (match_operand:SI 1 "nonimmediate_operand" "")))
!    (clobber (reg:CC FLAGS_REG))]
!   "TARGET_POPCNT"
!   "popcnt{l}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_rep" "1")
!    (set_attr "type" "bitmanip")
!    (set_attr "mode" "SI")])
! 
! (define_insn "*popcountsi2_cmp"
!   [(set (reg FLAGS_REG)
! 	(compare
! 	  (popcount:SI (match_operand:SI 1 "nonimmediate_operand" "rm"))
! 	  (const_int 0)))
!    (set (match_operand:SI 0 "register_operand" "=r")
! 	(popcount:SI (match_dup 1)))]
!   "TARGET_POPCNT && ix86_match_ccmode (insn, CCZmode)"
!   "popcnt{l}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_rep" "1")
!    (set_attr "type" "bitmanip")
!    (set_attr "mode" "SI")])
! 
! (define_insn "*popcountsi2_cmp_zext"
!   [(set (reg FLAGS_REG)
!         (compare
!           (popcount:SI (match_operand:SI 1 "nonimmediate_operand" "rm"))
!           (const_int 0)))
!    (set (match_operand:DI 0 "register_operand" "=r")
!         (zero_extend:DI(popcount:SI (match_dup 1))))]
!   "TARGET_64BIT && TARGET_POPCNT && ix86_match_ccmode (insn, CCZmode)"
!   "popcnt{l}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_rep" "1")
!    (set_attr "type" "bitmanip")
!    (set_attr "mode" "SI")])
  
  (define_expand "clzdi2"
    [(parallel
***************
*** 14579,14585 ****
       [(set (match_dup 0) (xor:DI (match_dup 0) (const_int 63)))
        (clobber (reg:CC FLAGS_REG))])]
    "TARGET_64BIT"
!   "")
  
  (define_insn "*bsr_rex64"
    [(set (match_operand:DI 0 "register_operand" "=r")
--- 14727,14749 ----
       [(set (match_dup 0) (xor:DI (match_dup 0) (const_int 63)))
        (clobber (reg:CC FLAGS_REG))])]
    "TARGET_64BIT"
! {
!   if (TARGET_ABM)
!     {
!       emit_insn (gen_clzdi2_abm (operands[0], operands[1]));
!       DONE;
!     }
! })
! 
! (define_insn "clzdi2_abm"
!   [(set (match_operand:DI 0 "register_operand" "=r")
! 	(clz:DI (match_operand:DI 1 "nonimmediate_operand" "")))
!    (clobber (reg:CC FLAGS_REG))]
!   "TARGET_64BIT && TARGET_ABM"
!   "lzcnt{q}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_rep" "1")
!    (set_attr "type" "bitmanip")
!    (set_attr "mode" "DI")])
  
  (define_insn "*bsr_rex64"
    [(set (match_operand:DI 0 "register_operand" "=r")
***************
*** 14588,14594 ****
     (clobber (reg:CC FLAGS_REG))]
    "TARGET_64BIT"
    "bsr{q}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_0f" "1")])
  
  ;; Thread-local storage patterns for ELF.
  ;;
--- 14752,14843 ----
     (clobber (reg:CC FLAGS_REG))]
    "TARGET_64BIT"
    "bsr{q}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_0f" "1")
!    (set_attr "mode" "DI")])
! 
! (define_insn "popcountdi2"
!   [(set (match_operand:DI 0 "register_operand" "=r")
! 	(popcount:DI (match_operand:DI 1 "nonimmediate_operand" "")))
!    (clobber (reg:CC FLAGS_REG))]
!   "TARGET_64BIT && TARGET_POPCNT"
!   "popcnt{q}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_rep" "1")
!    (set_attr "type" "bitmanip")
!    (set_attr "mode" "DI")])
! 
! (define_insn "*popcountdi2_cmp"
!   [(set (reg FLAGS_REG)
! 	(compare
! 	  (popcount:DI (match_operand:DI 1 "nonimmediate_operand" "rm"))
! 	  (const_int 0)))
!    (set (match_operand:DI 0 "register_operand" "=r")
! 	(popcount:DI (match_dup 1)))]
!   "TARGET_64BIT && TARGET_POPCNT && ix86_match_ccmode (insn, CCZmode)"
!   "popcnt{q}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_rep" "1")
!    (set_attr "type" "bitmanip")
!    (set_attr "mode" "DI")])
! 
! (define_expand "clzhi2"
!   [(parallel
!      [(set (match_operand:HI 0 "register_operand" "")
! 	   (minus:HI (const_int 15)
! 		     (clz:HI (match_operand:HI 1 "nonimmediate_operand" ""))))
!       (clobber (reg:CC FLAGS_REG))])
!    (parallel
!      [(set (match_dup 0) (xor:HI (match_dup 0) (const_int 15)))
!       (clobber (reg:CC FLAGS_REG))])]
!   ""
! {
!   if (TARGET_ABM)
!     {
!       emit_insn (gen_clzhi2_abm (operands[0], operands[1]));
!       DONE;
!     }
! })
! 
! (define_insn "clzhi2_abm"
!   [(set (match_operand:HI 0 "register_operand" "=r")
! 	(clz:HI (match_operand:HI 1 "nonimmediate_operand" "")))
!    (clobber (reg:CC FLAGS_REG))]
!   "TARGET_ABM"
!   "lzcnt{w}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_rep" "1")
!    (set_attr "type" "bitmanip")
!    (set_attr "mode" "HI")])
! 
! (define_insn "*bsrhi"
!   [(set (match_operand:HI 0 "register_operand" "=r")
! 	(minus:HI (const_int 15)
! 		  (clz:HI (match_operand:HI 1 "nonimmediate_operand" "rm"))))
!    (clobber (reg:CC FLAGS_REG))]
!   ""
!   "bsr{w}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_0f" "1")
!    (set_attr "mode" "HI")])
! 
! (define_insn "popcounthi2"
!   [(set (match_operand:HI 0 "register_operand" "=r")
! 	(popcount:HI (match_operand:HI 1 "nonimmediate_operand" "")))
!    (clobber (reg:CC FLAGS_REG))]
!   "TARGET_POPCNT"
!   "popcnt{w}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_rep" "1")
!    (set_attr "type" "bitmanip")
!    (set_attr "mode" "HI")])
! 
! (define_insn "*popcounthi2_cmp"
!   [(set (reg FLAGS_REG)
!         (compare
!           (popcount:HI (match_operand:HI 1 "nonimmediate_operand" "rm"))
!           (const_int 0)))
!    (set (match_operand:HI 0 "register_operand" "=r")
!         (popcount:HI (match_dup 1)))]
!   "TARGET_POPCNT && ix86_match_ccmode (insn, CCZmode)"
!   "popcnt{w}\t{%1, %0|%0, %1}"
!   [(set_attr "prefix_rep" "1")
!    (set_attr "type" "bitmanip")
!    (set_attr "mode" "HI")])
  
  ;; Thread-local storage patterns for ELF.
  ;;
***************
*** 15503,15509 ****
    "sqrtss\t{%1, %0|%0, %1}"
    [(set_attr "type" "sse")
     (set_attr "mode" "SF")
!    (set_attr "athlon_decode" "*")])
  
  (define_insn "*sqrtsf2_i387"
    [(set (match_operand:SF 0 "register_operand" "=f")
--- 15752,15759 ----
    "sqrtss\t{%1, %0|%0, %1}"
    [(set_attr "type" "sse")
     (set_attr "mode" "SF")
!    (set_attr "athlon_decode" "*")
!    (set_attr "amdfam10_decode" "*")])
  
  (define_insn "*sqrtsf2_i387"
    [(set (match_operand:SF 0 "register_operand" "=f")
***************
*** 15541,15547 ****
    "sqrtsd\t{%1, %0|%0, %1}"
    [(set_attr "type" "sse")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "*")])
  
  (define_insn "*sqrtdf2_i387"
    [(set (match_operand:DF 0 "register_operand" "=f")
--- 15791,15798 ----
    "sqrtsd\t{%1, %0|%0, %1}"
    [(set_attr "type" "sse")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "*")
!    (set_attr "amdfam10_decode" "*")])
  
  (define_insn "*sqrtdf2_i387"
    [(set (match_operand:DF 0 "register_operand" "=f")
***************
*** 15570,15576 ****
    "fsqrt"
    [(set_attr "type" "fpspc")
     (set_attr "mode" "XF")
!    (set_attr "athlon_decode" "direct")])
  
  (define_insn "*sqrtextendsfxf2_i387"
    [(set (match_operand:XF 0 "register_operand" "=f")
--- 15821,15828 ----
    "fsqrt"
    [(set_attr "type" "fpspc")
     (set_attr "mode" "XF")
!    (set_attr "athlon_decode" "direct")
!    (set_attr "amdfam10_decode" "direct")])
  
  (define_insn "*sqrtextendsfxf2_i387"
    [(set (match_operand:XF 0 "register_operand" "=f")
***************
*** 15580,15586 ****
    "fsqrt"
    [(set_attr "type" "fpspc")
     (set_attr "mode" "XF")
!    (set_attr "athlon_decode" "direct")])
  
  (define_insn "*sqrtextenddfxf2_i387"
    [(set (match_operand:XF 0 "register_operand" "=f")
--- 15832,15839 ----
    "fsqrt"
    [(set_attr "type" "fpspc")
     (set_attr "mode" "XF")
!    (set_attr "athlon_decode" "direct")   
!    (set_attr "amdfam10_decode" "direct")])
  
  (define_insn "*sqrtextenddfxf2_i387"
    [(set (match_operand:XF 0 "register_operand" "=f")
***************
*** 20391,20397 ****
  		   (mult:DI (match_operand:DI 1 "memory_operand" "")
  			    (match_operand:DI 2 "immediate_operand" "")))
  	      (clobber (reg:CC FLAGS_REG))])]
!   "(TARGET_K8 || TARGET_GENERIC64) && !optimize_size
     && !satisfies_constraint_K (operands[2])"
    [(set (match_dup 3) (match_dup 1))
     (parallel [(set (match_dup 0) (mult:DI (match_dup 3) (match_dup 2)))
--- 20644,20650 ----
  		   (mult:DI (match_operand:DI 1 "memory_operand" "")
  			    (match_operand:DI 2 "immediate_operand" "")))
  	      (clobber (reg:CC FLAGS_REG))])]
!   "(TARGET_K8 || TARGET_GENERIC64 || TARGET_AMDFAM10) && !optimize_size
     && !satisfies_constraint_K (operands[2])"
    [(set (match_dup 3) (match_dup 1))
     (parallel [(set (match_dup 0) (mult:DI (match_dup 3) (match_dup 2)))
***************
*** 20404,20410 ****
  		   (mult:SI (match_operand:SI 1 "memory_operand" "")
  			    (match_operand:SI 2 "immediate_operand" "")))
  	      (clobber (reg:CC FLAGS_REG))])]
!   "(TARGET_K8 || TARGET_GENERIC64) && !optimize_size
     && !satisfies_constraint_K (operands[2])"
    [(set (match_dup 3) (match_dup 1))
     (parallel [(set (match_dup 0) (mult:SI (match_dup 3) (match_dup 2)))
--- 20657,20663 ----
  		   (mult:SI (match_operand:SI 1 "memory_operand" "")
  			    (match_operand:SI 2 "immediate_operand" "")))
  	      (clobber (reg:CC FLAGS_REG))])]
!   "(TARGET_K8 || TARGET_GENERIC64 || TARGET_AMDFAM10) && !optimize_size
     && !satisfies_constraint_K (operands[2])"
    [(set (match_dup 3) (match_dup 1))
     (parallel [(set (match_dup 0) (mult:SI (match_dup 3) (match_dup 2)))
***************
*** 20418,20424 ****
  		     (mult:SI (match_operand:SI 1 "memory_operand" "")
  			      (match_operand:SI 2 "immediate_operand" ""))))
  	      (clobber (reg:CC FLAGS_REG))])]
!   "(TARGET_K8 || TARGET_GENERIC64) && !optimize_size
     && !satisfies_constraint_K (operands[2])"
    [(set (match_dup 3) (match_dup 1))
     (parallel [(set (match_dup 0) (zero_extend:DI (mult:SI (match_dup 3) (match_dup 2))))
--- 20671,20677 ----
  		     (mult:SI (match_operand:SI 1 "memory_operand" "")
  			      (match_operand:SI 2 "immediate_operand" ""))))
  	      (clobber (reg:CC FLAGS_REG))])]
!   "(TARGET_K8 || TARGET_GENERIC64 || TARGET_AMDFAM10) && !optimize_size
     && !satisfies_constraint_K (operands[2])"
    [(set (match_dup 3) (match_dup 1))
     (parallel [(set (match_dup 0) (zero_extend:DI (mult:SI (match_dup 3) (match_dup 2))))
***************
*** 20435,20441 ****
  			    (match_operand:DI 2 "const_int_operand" "")))
  	      (clobber (reg:CC FLAGS_REG))])
     (match_scratch:DI 3 "r")]
!   "(TARGET_K8 || TARGET_GENERIC64) && !optimize_size
     && satisfies_constraint_K (operands[2])"
    [(set (match_dup 3) (match_dup 2))
     (parallel [(set (match_dup 0) (mult:DI (match_dup 0) (match_dup 3)))
--- 20688,20694 ----
  			    (match_operand:DI 2 "const_int_operand" "")))
  	      (clobber (reg:CC FLAGS_REG))])
     (match_scratch:DI 3 "r")]
!   "(TARGET_K8 || TARGET_GENERIC64 || TARGET_AMDFAM10) && !optimize_size
     && satisfies_constraint_K (operands[2])"
    [(set (match_dup 3) (match_dup 2))
     (parallel [(set (match_dup 0) (mult:DI (match_dup 0) (match_dup 3)))
***************
*** 20451,20457 ****
  			    (match_operand:SI 2 "const_int_operand" "")))
  	      (clobber (reg:CC FLAGS_REG))])
     (match_scratch:SI 3 "r")]
!   "(TARGET_K8 || TARGET_GENERIC64) && !optimize_size
     && satisfies_constraint_K (operands[2])"
    [(set (match_dup 3) (match_dup 2))
     (parallel [(set (match_dup 0) (mult:SI (match_dup 0) (match_dup 3)))
--- 20704,20710 ----
  			    (match_operand:SI 2 "const_int_operand" "")))
  	      (clobber (reg:CC FLAGS_REG))])
     (match_scratch:SI 3 "r")]
!   "(TARGET_K8 || TARGET_GENERIC64 || TARGET_AMDFAM10) && !optimize_size
     && satisfies_constraint_K (operands[2])"
    [(set (match_dup 3) (match_dup 2))
     (parallel [(set (match_dup 0) (mult:SI (match_dup 0) (match_dup 3)))
***************
*** 20467,20473 ****
  			    (match_operand:HI 2 "immediate_operand" "")))
  	      (clobber (reg:CC FLAGS_REG))])
     (match_scratch:HI 3 "r")]
!   "(TARGET_K8 || TARGET_GENERIC64) && !optimize_size"
    [(set (match_dup 3) (match_dup 2))
     (parallel [(set (match_dup 0) (mult:HI (match_dup 0) (match_dup 3)))
  	      (clobber (reg:CC FLAGS_REG))])]
--- 20720,20726 ----
  			    (match_operand:HI 2 "immediate_operand" "")))
  	      (clobber (reg:CC FLAGS_REG))])
     (match_scratch:HI 3 "r")]
!   "(TARGET_K8 || TARGET_GENERIC64 || TARGET_AMDFAM10) && !optimize_size"
    [(set (match_dup 3) (match_dup 2))
     (parallel [(set (match_dup 0) (mult:HI (match_dup 0) (match_dup 3)))
  	      (clobber (reg:CC FLAGS_REG))])]
*** ../gcc.orig/./config/i386/athlon.md	2011-05-12 12:34:22.000000000 +0300
--- ./config/i386/athlon.md	2011-11-15 08:40:11.000000000 +0200
***************
*** 29,34 ****
--- 29,36 ----
  	   (const_string "vector")]
  	(const_string "direct")))
  
+ (define_attr "amdfam10_decode" "direct,vector,double"
+   (const_string "direct"))
  ;;
  ;;           decode0 decode1 decode2
  ;;                 \    |   /
***************
*** 131,148 ****
  
  ;; Jump instructions are executed in the branch unit completely transparent to us
  (define_insn_reservation "athlon_branch" 0
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "ibr"))
  			 "athlon-direct,athlon-ieu")
  (define_insn_reservation "athlon_call" 0
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "call,callv"))
  			 "athlon-vector,athlon-ieu")
  
  ;; Latency of push operation is 3 cycles, but ESP value is available
  ;; earlier
  (define_insn_reservation "athlon_push" 2
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "push"))
  			 "athlon-direct,athlon-agu,athlon-store")
  (define_insn_reservation "athlon_pop" 4
--- 133,154 ----
  
  ;; Jump instructions are executed in the branch unit completely transparent to us
  (define_insn_reservation "athlon_branch" 0
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (eq_attr "type" "ibr"))
  			 "athlon-direct,athlon-ieu")
  (define_insn_reservation "athlon_call" 0
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "call,callv"))
  			 "athlon-vector,athlon-ieu")
+ (define_insn_reservation "athlon_call_amdfam10" 0
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (eq_attr "type" "call,callv"))
+ 			 "athlon-double,athlon-ieu")
  
  ;; Latency of push operation is 3 cycles, but ESP value is available
  ;; earlier
  (define_insn_reservation "athlon_push" 2
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (eq_attr "type" "push"))
  			 "athlon-direct,athlon-agu,athlon-store")
  (define_insn_reservation "athlon_pop" 4
***************
*** 153,164 ****
  			 (and (eq_attr "cpu" "k8,generic64")
  			      (eq_attr "type" "pop"))
  			 "athlon-double,(athlon-ieu+athlon-load)")
  (define_insn_reservation "athlon_leave" 3
  			 (and (eq_attr "cpu" "athlon")
  			      (eq_attr "type" "leave"))
  			 "athlon-vector,(athlon-ieu+athlon-load)")
  (define_insn_reservation "athlon_leave_k8" 3
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (eq_attr "type" "leave"))
  			 "athlon-double,(athlon-ieu+athlon-load)")
  
--- 159,174 ----
  			 (and (eq_attr "cpu" "k8,generic64")
  			      (eq_attr "type" "pop"))
  			 "athlon-double,(athlon-ieu+athlon-load)")
+ (define_insn_reservation "athlon_pop_amdfam10" 3
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (eq_attr "type" "pop"))
+ 			 "athlon-direct,(athlon-ieu+athlon-load)")
  (define_insn_reservation "athlon_leave" 3
  			 (and (eq_attr "cpu" "athlon")
  			      (eq_attr "type" "leave"))
  			 "athlon-vector,(athlon-ieu+athlon-load)")
  (define_insn_reservation "athlon_leave_k8" 3
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (eq_attr "type" "leave"))
  			 "athlon-double,(athlon-ieu+athlon-load)")
  
***************
*** 167,172 ****
--- 177,187 ----
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "lea"))
  			 "athlon-direct,athlon-agu,nothing")
+ ;; Lea executes in AGU unit with 1 cycle latency on AMDFAM10
+ (define_insn_reservation "athlon_lea_amdfam10" 1
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (eq_attr "type" "lea"))
+ 			 "athlon-direct,athlon-agu,nothing")
  
  ;; Mul executes in special multiplier unit attached to IEU0
  (define_insn_reservation "athlon_imul" 5
***************
*** 176,204 ****
  			 "athlon-vector,athlon-ieu0,athlon-mult,nothing,nothing,athlon-ieu0")
  ;; ??? Widening multiply is vector or double.
  (define_insn_reservation "athlon_imul_k8_DI" 4
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "imul")
  				   (and (eq_attr "mode" "DI")
  					(eq_attr "memory" "none,unknown"))))
  			 "athlon-direct0,athlon-ieu0,athlon-mult,nothing,athlon-ieu0")
  (define_insn_reservation "athlon_imul_k8" 3
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "imul")
  				   (eq_attr "memory" "none,unknown")))
  			 "athlon-direct0,athlon-ieu0,athlon-mult,athlon-ieu0")
  (define_insn_reservation "athlon_imul_mem" 8
  			 (and (eq_attr "cpu" "athlon")
  			      (and (eq_attr "type" "imul")
  				   (eq_attr "memory" "load,both")))
  			 "athlon-vector,athlon-load,athlon-ieu,athlon-mult,nothing,nothing,athlon-ieu")
  (define_insn_reservation "athlon_imul_mem_k8_DI" 7
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "imul")
  				   (and (eq_attr "mode" "DI")
  					(eq_attr "memory" "load,both"))))
  			 "athlon-vector,athlon-load,athlon-ieu,athlon-mult,nothing,athlon-ieu")
  (define_insn_reservation "athlon_imul_mem_k8" 6
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "imul")
  				   (eq_attr "memory" "load,both")))
  			 "athlon-vector,athlon-load,athlon-ieu,athlon-mult,athlon-ieu")
--- 191,225 ----
  			 "athlon-vector,athlon-ieu0,athlon-mult,nothing,nothing,athlon-ieu0")
  ;; ??? Widening multiply is vector or double.
  (define_insn_reservation "athlon_imul_k8_DI" 4
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "imul")
  				   (and (eq_attr "mode" "DI")
  					(eq_attr "memory" "none,unknown"))))
  			 "athlon-direct0,athlon-ieu0,athlon-mult,nothing,athlon-ieu0")
  (define_insn_reservation "athlon_imul_k8" 3
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "imul")
  				   (eq_attr "memory" "none,unknown")))
  			 "athlon-direct0,athlon-ieu0,athlon-mult,athlon-ieu0")
+ (define_insn_reservation "athlon_imul_amdfam10_HI" 4
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "imul")
+ 				   (and (eq_attr "mode" "HI")
+ 					(eq_attr "memory" "none,unknown"))))
+ 			 "athlon-vector,athlon-ieu0,athlon-mult,nothing,athlon-ieu0")			 
  (define_insn_reservation "athlon_imul_mem" 8
  			 (and (eq_attr "cpu" "athlon")
  			      (and (eq_attr "type" "imul")
  				   (eq_attr "memory" "load,both")))
  			 "athlon-vector,athlon-load,athlon-ieu,athlon-mult,nothing,nothing,athlon-ieu")
  (define_insn_reservation "athlon_imul_mem_k8_DI" 7
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "imul")
  				   (and (eq_attr "mode" "DI")
  					(eq_attr "memory" "load,both"))))
  			 "athlon-vector,athlon-load,athlon-ieu,athlon-mult,nothing,athlon-ieu")
  (define_insn_reservation "athlon_imul_mem_k8" 6
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "imul")
  				   (eq_attr "memory" "load,both")))
  			 "athlon-vector,athlon-load,athlon-ieu,athlon-mult,athlon-ieu")
***************
*** 209,229 ****
  ;; other instructions.
  ;; ??? Experiments show that the idiv can overlap with roughly 6 cycles
  ;; of the other code
  
  (define_insn_reservation "athlon_idiv" 6
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "idiv")
  				   (eq_attr "memory" "none,unknown")))
  			 "athlon-vector,(athlon-ieu0*6+(athlon-fpsched,athlon-fvector))")
  (define_insn_reservation "athlon_idiv_mem" 9
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "idiv")
  				   (eq_attr "memory" "load,both")))
  			 "athlon-vector,((athlon-load,athlon-ieu0*6)+(athlon-fpsched,athlon-fvector))")
  ;; The parallelism of string instructions is not documented.  Model it same way
  ;; as idiv to create smaller automata.  This probably does not matter much.
  (define_insn_reservation "athlon_str" 6
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "str")
  				   (eq_attr "memory" "load,both,store")))
  			 "athlon-vector,athlon-load,athlon-ieu0*6")
--- 230,252 ----
  ;; other instructions.
  ;; ??? Experiments show that the idiv can overlap with roughly 6 cycles
  ;; of the other code
+ ;; Using the same heuristics for amdfam10 as K8 with idiv
  
  (define_insn_reservation "athlon_idiv" 6
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "type" "idiv")
  				   (eq_attr "memory" "none,unknown")))
  			 "athlon-vector,(athlon-ieu0*6+(athlon-fpsched,athlon-fvector))")
  (define_insn_reservation "athlon_idiv_mem" 9
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "type" "idiv")
  				   (eq_attr "memory" "load,both")))
  			 "athlon-vector,((athlon-load,athlon-ieu0*6)+(athlon-fpsched,athlon-fvector))")
  ;; The parallelism of string instructions is not documented.  Model it same way
  ;; as idiv to create smaller automata.  This probably does not matter much.
+ ;; Using the same heuristics for amdfam10 as K8 with idiv
  (define_insn_reservation "athlon_str" 6
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "type" "str")
  				   (eq_attr "memory" "load,both,store")))
  			 "athlon-vector,athlon-load,athlon-ieu0*6")
***************
*** 234,267 ****
  				   (and (eq_attr "unit" "integer,unknown")
  					(eq_attr "memory" "none,unknown"))))
  			 "athlon-direct,athlon-ieu")
  (define_insn_reservation "athlon_ivector" 2
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "vector")
  				   (and (eq_attr "unit" "integer,unknown")
  					(eq_attr "memory" "none,unknown"))))
  			 "athlon-vector,athlon-ieu,athlon-ieu")
  (define_insn_reservation "athlon_idirect_loadmov" 3
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "imov")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-load")
  (define_insn_reservation "athlon_idirect_load" 4
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "direct")
  				   (and (eq_attr "unit" "integer,unknown")
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-load,athlon-ieu")
  (define_insn_reservation "athlon_ivector_load" 6
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "vector")
  				   (and (eq_attr "unit" "integer,unknown")
  					(eq_attr "memory" "load"))))
  			 "athlon-vector,athlon-load,athlon-ieu,athlon-ieu")
  (define_insn_reservation "athlon_idirect_movstore" 1
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "imov")
  				   (eq_attr "memory" "store")))
  			 "athlon-direct,athlon-agu,athlon-store")
  (define_insn_reservation "athlon_idirect_both" 4
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "direct")
--- 257,318 ----
  				   (and (eq_attr "unit" "integer,unknown")
  					(eq_attr "memory" "none,unknown"))))
  			 "athlon-direct,athlon-ieu")
+ (define_insn_reservation "athlon_idirect_amdfam10" 1
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "amdfam10_decode" "direct")
+ 				   (and (eq_attr "unit" "integer,unknown")
+ 					(eq_attr "memory" "none,unknown"))))
+ 			 "athlon-direct,athlon-ieu")
  (define_insn_reservation "athlon_ivector" 2
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "vector")
  				   (and (eq_attr "unit" "integer,unknown")
  					(eq_attr "memory" "none,unknown"))))
  			 "athlon-vector,athlon-ieu,athlon-ieu")
+ (define_insn_reservation "athlon_ivector_amdfam10" 2
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "amdfam10_decode" "vector")
+ 				   (and (eq_attr "unit" "integer,unknown")
+ 					(eq_attr "memory" "none,unknown"))))
+ 			 "athlon-vector,athlon-ieu,athlon-ieu")
+ 
  (define_insn_reservation "athlon_idirect_loadmov" 3
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "type" "imov")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-load")
+ 
  (define_insn_reservation "athlon_idirect_load" 4
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "direct")
  				   (and (eq_attr "unit" "integer,unknown")
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-load,athlon-ieu")
+ (define_insn_reservation "athlon_idirect_load_amdfam10" 4
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "amdfam10_decode" "direct")
+ 				   (and (eq_attr "unit" "integer,unknown")
+ 					(eq_attr "memory" "load"))))
+ 			 "athlon-direct,athlon-load,athlon-ieu")
  (define_insn_reservation "athlon_ivector_load" 6
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "vector")
  				   (and (eq_attr "unit" "integer,unknown")
  					(eq_attr "memory" "load"))))
  			 "athlon-vector,athlon-load,athlon-ieu,athlon-ieu")
+ (define_insn_reservation "athlon_ivector_load_amdfam10" 6
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "amdfam10_decode" "vector")
+ 				   (and (eq_attr "unit" "integer,unknown")
+ 					(eq_attr "memory" "load"))))
+ 			 "athlon-vector,athlon-load,athlon-ieu,athlon-ieu")
+ 
  (define_insn_reservation "athlon_idirect_movstore" 1
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "type" "imov")
  				   (eq_attr "memory" "store")))
  			 "athlon-direct,athlon-agu,athlon-store")
+ 
  (define_insn_reservation "athlon_idirect_both" 4
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "direct")
***************
*** 270,275 ****
--- 321,335 ----
  			 "athlon-direct,athlon-load,
  			  athlon-ieu,athlon-store,
  			  athlon-store")
+ (define_insn_reservation "athlon_idirect_both_amdfam10" 4
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "amdfam10_decode" "direct")
+ 				   (and (eq_attr "unit" "integer,unknown")
+ 					(eq_attr "memory" "both"))))
+ 			 "athlon-direct,athlon-load,
+ 			  athlon-ieu,athlon-store,
+ 			  athlon-store")			  
+ 
  (define_insn_reservation "athlon_ivector_both" 6
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "vector")
***************
*** 279,284 ****
--- 339,354 ----
  			  athlon-ieu,
  			  athlon-ieu,
  			  athlon-store")
+ (define_insn_reservation "athlon_ivector_both_amdfam10" 6
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "amdfam10_decode" "vector")
+ 				   (and (eq_attr "unit" "integer,unknown")
+ 					(eq_attr "memory" "both"))))
+ 			 "athlon-vector,athlon-load,
+ 			  athlon-ieu,
+ 			  athlon-ieu,
+ 			  athlon-store")
+ 
  (define_insn_reservation "athlon_idirect_store" 1
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "direct")
***************
*** 286,291 ****
--- 356,369 ----
  					(eq_attr "memory" "store"))))
  			 "athlon-direct,(athlon-ieu+athlon-agu),
  			  athlon-store")
+ (define_insn_reservation "athlon_idirect_store_amdfam10" 1
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "amdfam10_decode" "direct")
+ 				   (and (eq_attr "unit" "integer,unknown")
+ 					(eq_attr "memory" "store"))))
+ 			 "athlon-direct,(athlon-ieu+athlon-agu),
+ 			  athlon-store")
+ 
  (define_insn_reservation "athlon_ivector_store" 2
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "vector")
***************
*** 293,298 ****
--- 371,383 ----
  					(eq_attr "memory" "store"))))
  			 "athlon-vector,(athlon-ieu+athlon-agu),athlon-ieu,
  			  athlon-store")
+ (define_insn_reservation "athlon_ivector_store_amdfam10" 2
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "amdfam10_decode" "vector")
+ 				   (and (eq_attr "unit" "integer,unknown")
+ 					(eq_attr "memory" "store"))))
+ 			 "athlon-vector,(athlon-ieu+athlon-agu),athlon-ieu,
+ 			  athlon-store")
  
  ;; Athlon floatin point unit
  (define_insn_reservation "athlon_fldxf" 12
***************
*** 302,308 ****
  					(eq_attr "mode" "XF"))))
  			 "athlon-vector,athlon-fpload2,athlon-fvector*9")
  (define_insn_reservation "athlon_fldxf_k8" 13
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "fmov")
  				   (and (eq_attr "memory" "load")
  					(eq_attr "mode" "XF"))))
--- 387,393 ----
  					(eq_attr "mode" "XF"))))
  			 "athlon-vector,athlon-fpload2,athlon-fvector*9")
  (define_insn_reservation "athlon_fldxf_k8" 13
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fmov")
  				   (and (eq_attr "memory" "load")
  					(eq_attr "mode" "XF"))))
***************
*** 314,320 ****
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fpload,athlon-fany")
  (define_insn_reservation "athlon_fld_k8" 2
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "fmov")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fstore")
--- 399,405 ----
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fpload,athlon-fany")
  (define_insn_reservation "athlon_fld_k8" 2
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fmov")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fstore")
***************
*** 326,332 ****
  					(eq_attr "mode" "XF"))))
  			 "athlon-vector,(athlon-fpsched+athlon-agu),(athlon-store2+(athlon-fvector*7))")
  (define_insn_reservation "athlon_fstxf_k8" 8
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "fmov")
  				   (and (eq_attr "memory" "store,both")
  					(eq_attr "mode" "XF"))))
--- 411,417 ----
  					(eq_attr "mode" "XF"))))
  			 "athlon-vector,(athlon-fpsched+athlon-agu),(athlon-store2+(athlon-fvector*7))")
  (define_insn_reservation "athlon_fstxf_k8" 8
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fmov")
  				   (and (eq_attr "memory" "store,both")
  					(eq_attr "mode" "XF"))))
***************
*** 337,352 ****
  				   (eq_attr "memory" "store,both")))
  			 "athlon-direct,(athlon-fpsched+athlon-agu),(athlon-fstore+athlon-store)")
  (define_insn_reservation "athlon_fst_k8" 2
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "fmov")
  				   (eq_attr "memory" "store,both")))
  			 "athlon-direct,(athlon-fpsched+athlon-agu),(athlon-fstore+athlon-store)")
  (define_insn_reservation "athlon_fist" 4
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "fistp,fisttp"))
  			 "athlon-direct,(athlon-fpsched+athlon-agu),(athlon-fstore+athlon-store)")
  (define_insn_reservation "athlon_fmov" 2
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "fmov"))
  			 "athlon-direct,athlon-fpsched,athlon-faddmul")
  (define_insn_reservation "athlon_fadd_load" 4
--- 422,437 ----
  				   (eq_attr "memory" "store,both")))
  			 "athlon-direct,(athlon-fpsched+athlon-agu),(athlon-fstore+athlon-store)")
  (define_insn_reservation "athlon_fst_k8" 2
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fmov")
  				   (eq_attr "memory" "store,both")))
  			 "athlon-direct,(athlon-fpsched+athlon-agu),(athlon-fstore+athlon-store)")
  (define_insn_reservation "athlon_fist" 4
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (eq_attr "type" "fistp,fisttp"))
  			 "athlon-direct,(athlon-fpsched+athlon-agu),(athlon-fstore+athlon-store)")
  (define_insn_reservation "athlon_fmov" 2
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (eq_attr "type" "fmov"))
  			 "athlon-direct,athlon-fpsched,athlon-faddmul")
  (define_insn_reservation "athlon_fadd_load" 4
***************
*** 355,366 ****
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fpload,athlon-fadd")
  (define_insn_reservation "athlon_fadd_load_k8" 6
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "fop")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_fadd" 4
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "fop"))
  			 "athlon-direct,athlon-fpsched,athlon-fadd")
  (define_insn_reservation "athlon_fmul_load" 4
--- 440,451 ----
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fpload,athlon-fadd")
  (define_insn_reservation "athlon_fadd_load_k8" 6
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fop")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_fadd" 4
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (eq_attr "type" "fop"))
  			 "athlon-direct,athlon-fpsched,athlon-fadd")
  (define_insn_reservation "athlon_fmul_load" 4
***************
*** 369,384 ****
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fpload,athlon-fmul")
  (define_insn_reservation "athlon_fmul_load_k8" 6
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "fmul")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fmul")
  (define_insn_reservation "athlon_fmul" 4
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "fmul"))
  			 "athlon-direct,athlon-fpsched,athlon-fmul")
  (define_insn_reservation "athlon_fsgn" 2
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "fsgn"))
  			 "athlon-direct,athlon-fpsched,athlon-fmul")
  (define_insn_reservation "athlon_fdiv_load" 24
--- 454,469 ----
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fpload,athlon-fmul")
  (define_insn_reservation "athlon_fmul_load_k8" 6
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fmul")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fmul")
  (define_insn_reservation "athlon_fmul" 4
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (eq_attr "type" "fmul"))
  			 "athlon-direct,athlon-fpsched,athlon-fmul")
  (define_insn_reservation "athlon_fsgn" 2
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (eq_attr "type" "fsgn"))
  			 "athlon-direct,athlon-fpsched,athlon-fmul")
  (define_insn_reservation "athlon_fdiv_load" 24
***************
*** 387,393 ****
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fpload,athlon-fmul")
  (define_insn_reservation "athlon_fdiv_load_k8" 13
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "fdiv")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fmul")
--- 472,478 ----
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fpload,athlon-fmul")
  (define_insn_reservation "athlon_fdiv_load_k8" 13
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fdiv")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fmul")
***************
*** 396,411 ****
  			      (eq_attr "type" "fdiv"))
  			 "athlon-direct,athlon-fpsched,athlon-fmul")
  (define_insn_reservation "athlon_fdiv_k8" 11
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (eq_attr "type" "fdiv"))
  			 "athlon-direct,athlon-fpsched,athlon-fmul")
  (define_insn_reservation "athlon_fpspc_load" 103
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "fpspc")
  				   (eq_attr "memory" "load")))
  			 "athlon-vector,athlon-fpload,athlon-fvector")
  (define_insn_reservation "athlon_fpspc" 100
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "fpspc"))
  			 "athlon-vector,athlon-fpsched,athlon-fvector")
  (define_insn_reservation "athlon_fcmov_load" 7
--- 481,496 ----
  			      (eq_attr "type" "fdiv"))
  			 "athlon-direct,athlon-fpsched,athlon-fmul")
  (define_insn_reservation "athlon_fdiv_k8" 11
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (eq_attr "type" "fdiv"))
  			 "athlon-direct,athlon-fpsched,athlon-fmul")
  (define_insn_reservation "athlon_fpspc_load" 103
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fpspc")
  				   (eq_attr "memory" "load")))
  			 "athlon-vector,athlon-fpload,athlon-fvector")
  (define_insn_reservation "athlon_fpspc" 100
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (eq_attr "type" "fpspc"))
  			 "athlon-vector,athlon-fpsched,athlon-fvector")
  (define_insn_reservation "athlon_fcmov_load" 7
***************
*** 418,429 ****
  			      (eq_attr "type" "fcmov"))
  			 "athlon-vector,athlon-fpsched,athlon-fvector")
  (define_insn_reservation "athlon_fcmov_load_k8" 17
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "fcmov")
  				   (eq_attr "memory" "load")))
  			 "athlon-vector,athlon-fploadk8,athlon-fvector")
  (define_insn_reservation "athlon_fcmov_k8" 15
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (eq_attr "type" "fcmov"))
  			 "athlon-vector,athlon-fpsched,athlon-fvector")
  ;; fcomi is vector decoded by uses only one pipe.
--- 503,514 ----
  			      (eq_attr "type" "fcmov"))
  			 "athlon-vector,athlon-fpsched,athlon-fvector")
  (define_insn_reservation "athlon_fcmov_load_k8" 17
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fcmov")
  				   (eq_attr "memory" "load")))
  			 "athlon-vector,athlon-fploadk8,athlon-fvector")
  (define_insn_reservation "athlon_fcmov_k8" 15
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (eq_attr "type" "fcmov"))
  			 "athlon-vector,athlon-fpsched,athlon-fvector")
  ;; fcomi is vector decoded by uses only one pipe.
***************
*** 434,446 ****
  				        (eq_attr "memory" "load"))))
  			 "athlon-vector,athlon-fpload,athlon-fadd")
  (define_insn_reservation "athlon_fcomi_load_k8" 5
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "fcmp")
  				   (and (eq_attr "athlon_decode" "vector")
  				        (eq_attr "memory" "load"))))
  			 "athlon-vector,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_fcomi" 3
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "athlon_decode" "vector")
  				   (eq_attr "type" "fcmp")))
  			 "athlon-vector,athlon-fpsched,athlon-fadd")
--- 519,531 ----
  				        (eq_attr "memory" "load"))))
  			 "athlon-vector,athlon-fpload,athlon-fadd")
  (define_insn_reservation "athlon_fcomi_load_k8" 5
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fcmp")
  				   (and (eq_attr "athlon_decode" "vector")
  				        (eq_attr "memory" "load"))))
  			 "athlon-vector,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_fcomi" 3
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "athlon_decode" "vector")
  				   (eq_attr "type" "fcmp")))
  			 "athlon-vector,athlon-fpsched,athlon-fadd")
***************
*** 450,467 ****
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fpload,athlon-fadd")
  (define_insn_reservation "athlon_fcom_load_k8" 4
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "fcmp")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_fcom" 2
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "fcmp"))
  			 "athlon-direct,athlon-fpsched,athlon-fadd")
  ;; Never seen by the scheduler because we still don't do post reg-stack
  ;; scheduling.
  ;(define_insn_reservation "athlon_fxch" 2
! ;			 (and (eq_attr "cpu" "athlon,k8,generic64")
  ;			      (eq_attr "type" "fxch"))
  ;			 "athlon-direct,athlon-fpsched,athlon-fany")
  
--- 535,552 ----
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fpload,athlon-fadd")
  (define_insn_reservation "athlon_fcom_load_k8" 4
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "fcmp")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_fcom" 2
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (eq_attr "type" "fcmp"))
  			 "athlon-direct,athlon-fpsched,athlon-fadd")
  ;; Never seen by the scheduler because we still don't do post reg-stack
  ;; scheduling.
  ;(define_insn_reservation "athlon_fxch" 2
! ;			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  ;			      (eq_attr "type" "fxch"))
  ;			 "athlon-direct,athlon-fpsched,athlon-fany")
  
***************
*** 516,521 ****
--- 601,623 ----
  			      (and (eq_attr "type" "mmxmov,ssemov")
  				   (eq_attr "memory" "load")))
  			 "athlon-direct,athlon-fploadk8,athlon-fstore")
+ ;; On AMDFAM10 all double, single and integer packed and scalar SSEx data
+ ;; loads  generated are direct path, latency of 2 and do not use any FP
+ ;; executions units. No seperate entries for movlpx/movhpx loads, which
+ ;; are direct path, latency of 4 and use the FADD/FMUL FP execution units,
+ ;; as they will not be generated.
+ (define_insn_reservation "athlon_sseld_amdfam10" 2
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssemov")
+ 				   (eq_attr "memory" "load")))
+ 			 "athlon-direct,athlon-fploadk8")
+ ;; On AMDFAM10 MMX data loads  generated are direct path, latency of 4
+ ;; and can use any  FP executions units
+ (define_insn_reservation "athlon_mmxld_amdfam10" 4
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "mmxmov")
+ 				   (eq_attr "memory" "load")))
+ 			 "athlon-direct,athlon-fploadk8, athlon-fany")			 
  (define_insn_reservation "athlon_mmxssest" 3
  			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "mmxmov,ssemov")
***************
*** 533,538 ****
--- 635,659 ----
  			      (and (eq_attr "type" "mmxmov,ssemov")
  				   (eq_attr "memory" "store,both")))
  			 "athlon-direct,(athlon-fpsched+athlon-agu),(athlon-fstore+athlon-store)")
+ ;; On AMDFAM10 all double, single and integer packed SSEx data stores
+ ;; generated are all double path, latency of 2 and use the FSTORE FP
+ ;; execution unit. No entries seperate for movupx/movdqu, which are
+ ;; vector path, latency of 3 and use the FSTORE*2 FP execution unit,
+ ;; as they will not be generated.
+ (define_insn_reservation "athlon_ssest_amdfam10" 2
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssemov")
+ 				   (and (eq_attr "mode" "V4SF,V2DF,TI")
+ 					(eq_attr "memory" "store,both"))))
+ 			 "athlon-double,(athlon-fpsched+athlon-agu),((athlon-fstore+athlon-store)*2)")
+ ;; On AMDFAM10 all double, single and integer scalar SSEx and MMX
+ ;; data stores generated are all direct path, latency of 2 and use
+ ;; the FSTORE FP execution unit
+ (define_insn_reservation "athlon_mmxssest_short_amdfam10" 2
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "mmxmov,ssemov")
+ 				   (eq_attr "memory" "store,both")))
+ 			 "athlon-direct,(athlon-fpsched+athlon-agu),(athlon-fstore+athlon-store)")
  (define_insn_reservation "athlon_movaps_k8" 2
  			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "ssemov")
***************
*** 578,583 ****
--- 699,709 ----
  			      (and (eq_attr "type" "sselog,sselog1")
  				   (eq_attr "memory" "load")))
  			 "athlon-double,athlon-fpload2k8,(athlon-fmul*2)")
+ (define_insn_reservation "athlon_sselog_load_amdfam10" 4
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "sselog,sselog1")
+ 				   (eq_attr "memory" "load")))
+ 			 "athlon-direct,athlon-fploadk8,(athlon-fadd|athlon-fmul)")
  (define_insn_reservation "athlon_sselog" 3
  			 (and (eq_attr "cpu" "athlon")
  			      (eq_attr "type" "sselog,sselog1"))
***************
*** 586,591 ****
--- 712,722 ----
  			 (and (eq_attr "cpu" "k8,generic64")
  			      (eq_attr "type" "sselog,sselog1"))
  			 "athlon-double,athlon-fpsched,athlon-fmul")
+ (define_insn_reservation "athlon_sselog_amdfam10" 2
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (eq_attr "type" "sselog,sselog1"))
+ 			 "athlon-direct,athlon-fpsched,(athlon-fadd|athlon-fmul)")
+ 
  ;; ??? pcmp executes in addmul, probably not worthwhile to bother about that.
  (define_insn_reservation "athlon_ssecmp_load" 2
  			 (and (eq_attr "cpu" "athlon")
***************
*** 594,606 ****
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fpload,athlon-fadd")
  (define_insn_reservation "athlon_ssecmp_load_k8" 4
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "ssecmp")
  				   (and (eq_attr "mode" "SF,DF,DI,TI")
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_ssecmp" 2
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "ssecmp")
  				   (eq_attr "mode" "SF,DF,DI,TI")))
  			 "athlon-direct,athlon-fpsched,athlon-fadd")
--- 725,737 ----
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fpload,athlon-fadd")
  (define_insn_reservation "athlon_ssecmp_load_k8" 4
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "ssecmp")
  				   (and (eq_attr "mode" "SF,DF,DI,TI")
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_ssecmp" 2
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "type" "ssecmp")
  				   (eq_attr "mode" "SF,DF,DI,TI")))
  			 "athlon-direct,athlon-fpsched,athlon-fadd")
***************
*** 614,619 ****
--- 745,755 ----
  			      (and (eq_attr "type" "ssecmp")
  				   (eq_attr "memory" "load")))
  			 "athlon-double,athlon-fpload2k8,(athlon-fadd*2)")
+ (define_insn_reservation "athlon_ssecmpvector_load_amdfam10" 4
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssecmp")
+ 				   (eq_attr "memory" "load")))
+ 			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_ssecmpvector" 3
  			 (and (eq_attr "cpu" "athlon")
  			      (eq_attr "type" "ssecmp"))
***************
*** 622,627 ****
--- 758,767 ----
  			 (and (eq_attr "cpu" "k8,generic64")
  			      (eq_attr "type" "ssecmp"))
  			 "athlon-double,athlon-fpsched,(athlon-fadd*2)")
+ (define_insn_reservation "athlon_ssecmpvector_amdfam10" 2
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (eq_attr "type" "ssecmp"))
+ 			 "athlon-direct,athlon-fpsched,athlon-fadd")
  (define_insn_reservation "athlon_ssecomi_load" 4
  			 (and (eq_attr "cpu" "athlon")
  			      (and (eq_attr "type" "ssecomi")
***************
*** 632,641 ****
--- 772,791 ----
  			      (and (eq_attr "type" "ssecomi")
  				   (eq_attr "memory" "load")))
  			 "athlon-vector,athlon-fploadk8,athlon-fadd")
+ (define_insn_reservation "athlon_ssecomi_load_amdfam10" 5
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssecomi")
+ 				   (eq_attr "memory" "load")))
+ 			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_ssecomi" 4
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (eq_attr "type" "ssecmp"))
  			 "athlon-vector,athlon-fpsched,athlon-fadd")
+ (define_insn_reservation "athlon_ssecomi_amdfam10" 3
+ 			 (and (eq_attr "cpu" "amdfam10")
+ ;; It seems athlon_ssecomi has a bug in the attr_type, fixed for amdfam10
+ 			      (eq_attr "type" "ssecomi"))
+ 			 "athlon-direct,athlon-fpsched,athlon-fadd")
  (define_insn_reservation "athlon_sseadd_load" 4
  			 (and (eq_attr "cpu" "athlon")
  			      (and (eq_attr "type" "sseadd")
***************
*** 643,655 ****
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fpload,athlon-fadd")
  (define_insn_reservation "athlon_sseadd_load_k8" 6
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "sseadd")
  				   (and (eq_attr "mode" "SF,DF,DI")
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_sseadd" 4
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "sseadd")
  				   (eq_attr "mode" "SF,DF,DI")))
  			 "athlon-direct,athlon-fpsched,athlon-fadd")
--- 793,805 ----
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fpload,athlon-fadd")
  (define_insn_reservation "athlon_sseadd_load_k8" 6
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "sseadd")
  				   (and (eq_attr "mode" "SF,DF,DI")
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_sseadd" 4
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "type" "sseadd")
  				   (eq_attr "mode" "SF,DF,DI")))
  			 "athlon-direct,athlon-fpsched,athlon-fadd")
***************
*** 663,668 ****
--- 813,823 ----
  			      (and (eq_attr "type" "sseadd")
  				   (eq_attr "memory" "load")))
  			 "athlon-double,athlon-fpload2k8,(athlon-fadd*2)")
+ (define_insn_reservation "athlon_sseaddvector_load_amdfam10" 6
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "sseadd")
+ 				   (eq_attr "memory" "load")))
+ 			 "athlon-direct,athlon-fploadk8,athlon-fadd")
  (define_insn_reservation "athlon_sseaddvector" 5
  			 (and (eq_attr "cpu" "athlon")
  			      (eq_attr "type" "sseadd"))
***************
*** 671,676 ****
--- 826,835 ----
  			 (and (eq_attr "cpu" "k8,generic64")
  			      (eq_attr "type" "sseadd"))
  			 "athlon-double,athlon-fpsched,(athlon-fadd*2)")
+ (define_insn_reservation "athlon_sseaddvector_amdfam10" 4
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (eq_attr "type" "sseadd"))
+ 			 "athlon-direct,athlon-fpsched,athlon-fadd")
  
  ;; Conversions behaves very irregularly and the scheduling is critical here.
  ;; Take each instruction separately.  Assume that the mode is always set to the
***************
*** 684,695 ****
--- 843,867 ----
  					(and (eq_attr "mode" "DF")
  					     (eq_attr "memory" "load")))))
  			 "athlon-direct,athlon-fploadk8,athlon-fstore")
+ (define_insn_reservation "athlon_ssecvt_cvtss2sd_load_amdfam10" 7
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssecvt")
+ 				   (and (eq_attr "amdfam10_decode" "double")
+ 					(and (eq_attr "mode" "DF")
+ 					     (eq_attr "memory" "load")))))
+ 			 "athlon-double,athlon-fploadk8,(athlon-faddmul+athlon-fstore)")
  (define_insn_reservation "athlon_ssecvt_cvtss2sd" 2
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "ssecvt")
  				   (and (eq_attr "athlon_decode" "direct")
  					(eq_attr "mode" "DF"))))
  			 "athlon-direct,athlon-fpsched,athlon-fstore")
+ (define_insn_reservation "athlon_ssecvt_cvtss2sd_amdfam10" 7
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssecvt")
+ 				   (and (eq_attr "amdfam10_decode" "vector")
+ 					(eq_attr "mode" "DF"))))
+ 			 "athlon-vector,athlon-fpsched,athlon-faddmul,(athlon-fstore*2)")
  ;; cvtps2pd.  Model same way the other double decoded FP conversions.
  (define_insn_reservation "athlon_ssecvt_cvtps2pd_load_k8" 5
  			 (and (eq_attr "cpu" "k8,athlon,generic64")
***************
*** 698,709 ****
--- 870,894 ----
  					(and (eq_attr "mode" "V2DF,V4SF,TI")
  					     (eq_attr "memory" "load")))))
  			 "athlon-double,athlon-fpload2k8,(athlon-fstore*2)")
+ (define_insn_reservation "athlon_ssecvt_cvtps2pd_load_amdfam10" 4
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssecvt")
+ 				   (and (eq_attr "amdfam10_decode" "direct")
+ 					(and (eq_attr "mode" "V2DF,V4SF,TI")
+ 					     (eq_attr "memory" "load")))))
+ 			 "athlon-direct,athlon-fploadk8,athlon-fstore")
  (define_insn_reservation "athlon_ssecvt_cvtps2pd_k8" 3
  			 (and (eq_attr "cpu" "k8,athlon,generic64")
  			      (and (eq_attr "type" "ssecvt")
  				   (and (eq_attr "athlon_decode" "double")
  					(eq_attr "mode" "V2DF,V4SF,TI"))))
  			 "athlon-double,athlon-fpsched,athlon-fstore,athlon-fstore")
+ (define_insn_reservation "athlon_ssecvt_cvtps2pd_amdfam10" 2
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssecvt")
+ 				   (and (eq_attr "amdfam10_decode" "direct")
+ 					(eq_attr "mode" "V2DF,V4SF,TI"))))
+ 			 "athlon-direct,athlon-fpsched,athlon-fstore")
  ;; cvtsi2sd mem,reg is directpath path  (cvtsi2sd reg,reg is doublepath)
  ;; cvtsi2sd has troughput 1 and is executed in store unit with latency of 6
  (define_insn_reservation "athlon_sseicvt_cvtsi2sd_load" 6
***************
*** 713,718 ****
--- 898,910 ----
  					(and (eq_attr "mode" "SF,DF")
  					     (eq_attr "memory" "load")))))
  			 "athlon-direct,athlon-fploadk8,athlon-fstore")
+ (define_insn_reservation "athlon_sseicvt_cvtsi2sd_load_amdfam10" 9
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "sseicvt")
+ 				   (and (eq_attr "amdfam10_decode" "double")
+ 					(and (eq_attr "mode" "SF,DF")
+ 					     (eq_attr "memory" "load")))))
+ 			 "athlon-double,athlon-fploadk8,(athlon-faddmul+athlon-fstore)")
  ;; cvtsi2ss mem, reg is doublepath
  (define_insn_reservation "athlon_sseicvt_cvtsi2ss_load" 9
  			 (and (eq_attr "cpu" "athlon")
***************
*** 728,733 ****
--- 920,932 ----
  					(and (eq_attr "mode" "SF,DF")
  					     (eq_attr "memory" "load")))))
  			 "athlon-double,athlon-fploadk8,(athlon-fstore*2)")
+ (define_insn_reservation "athlon_sseicvt_cvtsi2ss_load_amdfam10" 9
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "sseicvt")
+ 				   (and (eq_attr "amdfam10_decode" "double")
+ 					(and (eq_attr "mode" "SF,DF")
+ 					     (eq_attr "memory" "load")))))
+ 			 "athlon-double,athlon-fploadk8,(athlon-faddmul+athlon-fstore)")			 
  ;; cvtsi2sd reg,reg is double decoded (vector on Athlon)
  (define_insn_reservation "athlon_sseicvt_cvtsi2sd_k8" 11
  			 (and (eq_attr "cpu" "k8,athlon,generic64")
***************
*** 736,741 ****
--- 935,947 ----
  					(and (eq_attr "mode" "SF,DF")
  					     (eq_attr "memory" "none")))))
  			 "athlon-double,athlon-fploadk8,athlon-fstore")
+ (define_insn_reservation "athlon_sseicvt_cvtsi2sd_amdfam10" 14
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "sseicvt")
+ 				   (and (eq_attr "amdfam10_decode" "vector")
+ 					(and (eq_attr "mode" "SF,DF")
+ 					     (eq_attr "memory" "none")))))
+ 			 "athlon-vector,athlon-fploadk8,(athlon-faddmul+athlon-fstore)")
  ;; cvtsi2ss reg, reg is doublepath
  (define_insn_reservation "athlon_sseicvt_cvtsi2ss" 14
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
***************
*** 744,749 ****
--- 950,962 ----
  					(and (eq_attr "mode" "SF,DF")
  					     (eq_attr "memory" "none")))))
  			 "athlon-vector,athlon-fploadk8,(athlon-fvector*2)")
+ (define_insn_reservation "athlon_sseicvt_cvtsi2ss_amdfam10" 14
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "sseicvt")
+ 				   (and (eq_attr "amdfam10_decode" "vector")
+ 					(and (eq_attr "mode" "SF,DF")
+ 					     (eq_attr "memory" "none")))))
+ 			 "athlon-vector,athlon-fploadk8,(athlon-faddmul+athlon-fstore)")
  ;; cvtsd2ss mem,reg is doublepath, troughput unknown, latency 9
  (define_insn_reservation "athlon_ssecvt_cvtsd2ss_load_k8" 9
  			 (and (eq_attr "cpu" "k8,athlon,generic64")
***************
*** 752,757 ****
--- 965,977 ----
  					(and (eq_attr "mode" "SF")
  					     (eq_attr "memory" "load")))))
  			 "athlon-double,athlon-fploadk8,(athlon-fstore*3)")
+ (define_insn_reservation "athlon_ssecvt_cvtsd2ss_load_amdfam10" 9
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssecvt")
+ 				   (and (eq_attr "amdfam10_decode" "double")
+ 					(and (eq_attr "mode" "SF")
+ 					     (eq_attr "memory" "load")))))
+ 			 "athlon-double,athlon-fploadk8,(athlon-faddmul+athlon-fstore)")
  ;; cvtsd2ss reg,reg is vectorpath, troughput unknown, latency 12
  (define_insn_reservation "athlon_ssecvt_cvtsd2ss" 12
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
***************
*** 760,765 ****
--- 980,992 ----
  					(and (eq_attr "mode" "SF")
  					     (eq_attr "memory" "none")))))
  			 "athlon-vector,athlon-fpsched,(athlon-fvector*3)")
+ (define_insn_reservation "athlon_ssecvt_cvtsd2ss_amdfam10" 8
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssecvt")
+ 				   (and (eq_attr "amdfam10_decode" "vector")
+ 					(and (eq_attr "mode" "SF")
+ 					     (eq_attr "memory" "none")))))
+ 			 "athlon-vector,athlon-fpsched,athlon-faddmul,(athlon-fstore*2)")
  (define_insn_reservation "athlon_ssecvt_cvtpd2ps_load_k8" 8
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "ssecvt")
***************
*** 767,772 ****
--- 994,1006 ----
  					(and (eq_attr "mode" "V4SF,V2DF,TI")
  					     (eq_attr "memory" "load")))))
  			 "athlon-double,athlon-fpload2k8,(athlon-fstore*3)")
+ (define_insn_reservation "athlon_ssecvt_cvtpd2ps_load_amdfam10" 9
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssecvt")
+ 				   (and (eq_attr "amdfam10_decode" "double")
+ 					(and (eq_attr "mode" "V4SF,V2DF,TI")
+ 					     (eq_attr "memory" "load")))))
+ 			 "athlon-double,athlon-fploadk8,(athlon-faddmul+athlon-fstore)")
  ;; cvtpd2ps mem,reg is vectorpath, troughput unknown, latency 10
  ;; ??? Why it is fater than cvtsd2ss?
  (define_insn_reservation "athlon_ssecvt_cvtpd2ps" 8
***************
*** 776,781 ****
--- 1010,1022 ----
  					(and (eq_attr "mode" "V4SF,V2DF,TI")
  					     (eq_attr "memory" "none")))))
  			 "athlon-vector,athlon-fpsched,athlon-fvector*2")
+ (define_insn_reservation "athlon_ssecvt_cvtpd2ps_amdfam10" 7
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssecvt")
+ 				   (and (eq_attr "amdfam10_decode" "double")
+ 					(and (eq_attr "mode" "V4SF,V2DF,TI")
+ 					     (eq_attr "memory" "none")))))
+ 			 "athlon-double,athlon-fpsched,(athlon-faddmul+athlon-fstore)")
  ;; cvtsd2si mem,reg is doublepath, troughput 1, latency 9
  (define_insn_reservation "athlon_secvt_cvtsX2si_load" 9
  			 (and (eq_attr "cpu" "athlon,k8,generic64")
***************
*** 784,789 ****
--- 1025,1037 ----
  					(and (eq_attr "mode" "SI,DI")
  					     (eq_attr "memory" "load")))))
  			 "athlon-vector,athlon-fploadk8,athlon-fvector")
+ (define_insn_reservation "athlon_secvt_cvtsX2si_load_amdfam10" 10
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "sseicvt")
+ 				   (and (eq_attr "amdfam10_decode" "double")
+ 					(and (eq_attr "mode" "SI,DI")
+ 					     (eq_attr "memory" "load")))))
+ 			 "athlon-double,athlon-fploadk8,(athlon-fadd+athlon-fstore)")
  ;; cvtsd2si reg,reg is doublepath, troughput 1, latency 9
  (define_insn_reservation "athlon_ssecvt_cvtsX2si" 9
  			 (and (eq_attr "cpu" "athlon")
***************
*** 799,804 ****
--- 1047,1075 ----
  					(and (eq_attr "mode" "SI,DI")
  					     (eq_attr "memory" "none")))))
  			 "athlon-double,athlon-fpsched,athlon-fstore")
+ (define_insn_reservation "athlon_ssecvt_cvtsX2si_amdfam10" 8
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "sseicvt")
+ 				   (and (eq_attr "amdfam10_decode" "double")
+ 					(and (eq_attr "mode" "SI,DI")
+ 					     (eq_attr "memory" "none")))))
+ 			 "athlon-double,athlon-fpsched,(athlon-fadd+athlon-fstore)")
+ ;; cvtpd2dq reg,mem is doublepath, troughput 1, latency 9 on amdfam10
+ (define_insn_reservation "athlon_sseicvt_cvtpd2dq_load_amdfam10" 9
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "sseicvt")
+ 				   (and (eq_attr "amdfam10_decode" "double")
+ 					(and (eq_attr "mode" "TI")
+ 					     (eq_attr "memory" "load")))))
+ 			 "athlon-double,athlon-fploadk8,(athlon-faddmul+athlon-fstore)")
+ ;; cvtpd2dq reg,mem is doublepath, troughput 1, latency 7 on amdfam10
+ (define_insn_reservation "athlon_sseicvt_cvtpd2dq_amdfam10" 7
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "sseicvt")
+ 				   (and (eq_attr "amdfam10_decode" "double")
+ 					(and (eq_attr "mode" "TI")
+ 					     (eq_attr "memory" "none")))))
+ 			 "athlon-double,athlon-fpsched,(athlon-faddmul+athlon-fstore)")
  
  
  (define_insn_reservation "athlon_ssemul_load" 4
***************
*** 808,820 ****
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fpload,athlon-fmul")
  (define_insn_reservation "athlon_ssemul_load_k8" 6
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "ssemul")
  				   (and (eq_attr "mode" "SF,DF")
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fploadk8,athlon-fmul")
  (define_insn_reservation "athlon_ssemul" 4
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "ssemul")
  				   (eq_attr "mode" "SF,DF")))
  			 "athlon-direct,athlon-fpsched,athlon-fmul")
--- 1079,1091 ----
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fpload,athlon-fmul")
  (define_insn_reservation "athlon_ssemul_load_k8" 6
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "ssemul")
  				   (and (eq_attr "mode" "SF,DF")
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fploadk8,athlon-fmul")
  (define_insn_reservation "athlon_ssemul" 4
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "type" "ssemul")
  				   (eq_attr "mode" "SF,DF")))
  			 "athlon-direct,athlon-fpsched,athlon-fmul")
***************
*** 828,833 ****
--- 1099,1109 ----
  			      (and (eq_attr "type" "ssemul")
  				   (eq_attr "memory" "load")))
  			 "athlon-double,athlon-fpload2k8,(athlon-fmul*2)")
+ (define_insn_reservation "athlon_ssemulvector_load_amdfam10" 6
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssemul")
+ 				   (eq_attr "memory" "load")))
+ 			 "athlon-direct,athlon-fploadk8,athlon-fmul")
  (define_insn_reservation "athlon_ssemulvector" 5
  			 (and (eq_attr "cpu" "athlon")
  			      (eq_attr "type" "ssemul"))
***************
*** 836,841 ****
--- 1112,1121 ----
  			 (and (eq_attr "cpu" "k8,generic64")
  			      (eq_attr "type" "ssemul"))
  			 "athlon-double,athlon-fpsched,(athlon-fmul*2)")
+ (define_insn_reservation "athlon_ssemulvector_amdfam10" 4
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (eq_attr "type" "ssemul"))
+ 			 "athlon-direct,athlon-fpsched,athlon-fmul")			 
  ;; divsd timings.  divss is faster
  (define_insn_reservation "athlon_ssediv_load" 20
  			 (and (eq_attr "cpu" "athlon")
***************
*** 844,856 ****
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fpload,athlon-fmul*17")
  (define_insn_reservation "athlon_ssediv_load_k8" 22
! 			 (and (eq_attr "cpu" "k8,generic64")
  			      (and (eq_attr "type" "ssediv")
  				   (and (eq_attr "mode" "SF,DF")
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fploadk8,athlon-fmul*17")
  (define_insn_reservation "athlon_ssediv" 20
! 			 (and (eq_attr "cpu" "athlon,k8,generic64")
  			      (and (eq_attr "type" "ssediv")
  				   (eq_attr "mode" "SF,DF")))
  			 "athlon-direct,athlon-fpsched,athlon-fmul*17")
--- 1124,1136 ----
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fpload,athlon-fmul*17")
  (define_insn_reservation "athlon_ssediv_load_k8" 22
! 			 (and (eq_attr "cpu" "k8,generic64,amdfam10")
  			      (and (eq_attr "type" "ssediv")
  				   (and (eq_attr "mode" "SF,DF")
  					(eq_attr "memory" "load"))))
  			 "athlon-direct,athlon-fploadk8,athlon-fmul*17")
  (define_insn_reservation "athlon_ssediv" 20
! 			 (and (eq_attr "cpu" "athlon,k8,generic64,amdfam10")
  			      (and (eq_attr "type" "ssediv")
  				   (eq_attr "mode" "SF,DF")))
  			 "athlon-direct,athlon-fpsched,athlon-fmul*17")
***************
*** 864,869 ****
--- 1144,1154 ----
  			      (and (eq_attr "type" "ssediv")
  				   (eq_attr "memory" "load")))
  			 "athlon-double,athlon-fpload2k8,athlon-fmul*34")
+ (define_insn_reservation "athlon_ssedivvector_load_amdfam10" 22
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (and (eq_attr "type" "ssediv")
+ 				   (eq_attr "memory" "load")))
+ 			 "athlon-direct,athlon-fploadk8,athlon-fmul*17")			 
  (define_insn_reservation "athlon_ssedivvector" 39
  			 (and (eq_attr "cpu" "athlon")
  			      (eq_attr "type" "ssediv"))
***************
*** 872,874 ****
--- 1157,1168 ----
  			 (and (eq_attr "cpu" "k8,generic64")
  			      (eq_attr "type" "ssediv"))
  			 "athlon-double,athlon-fmul*34")
+ (define_insn_reservation "athlon_ssedivvector_amdfam10" 20
+ 			 (and (eq_attr "cpu" "amdfam10")
+ 			      (eq_attr "type" "ssediv"))
+ 			 "athlon-direct,athlon-fmul*17")
+ (define_insn_reservation "athlon_sseins_amdfam10" 5
+                          (and (eq_attr "cpu" "amdfam10")
+                               (and (eq_attr "type" "sseins")
+                                    (eq_attr "mode" "TI")))
+                          "athlon-vector,athlon-fpsched,athlon-faddmul")
*** ../gcc.orig/./config/i386/pmmintrin.h	2011-05-12 12:34:22.000000000 +0300
--- ./config/i386/pmmintrin.h	2011-11-15 08:40:11.000000000 +0200
***************
*** 1,4 ****
! /* Copyright (C) 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
  
     This file is part of GCC.
  
--- 1,4 ----
! /* Copyright (C) 2003, 2004, 2005, 2006, 2007 Free Software Foundation, Inc.
  
     This file is part of GCC.
  
***************
*** 30,36 ****
  #ifndef _PMMINTRIN_H_INCLUDED
  #define _PMMINTRIN_H_INCLUDED
  
! #ifdef __SSE3__
  #include <xmmintrin.h>
  #include <emmintrin.h>
  
--- 30,40 ----
  #ifndef _PMMINTRIN_H_INCLUDED
  #define _PMMINTRIN_H_INCLUDED
  
! #ifndef __SSE3__
! # error "SSE3 instruction set not enabled"
! #else
! 
! /* We need definitions from the SSE2 and SSE header files*/
  #include <xmmintrin.h>
  #include <emmintrin.h>
  
*** ../gcc.orig/./config/i386/tmmintrin.h	2011-05-12 12:34:22.000000000 +0300
--- ./config/i386/tmmintrin.h	2011-11-15 08:40:11.000000000 +0200
***************
*** 1,4 ****
! /* Copyright (C) 2006 Free Software Foundation, Inc.
  
     This file is part of GCC.
  
--- 1,4 ----
! /* Copyright (C) 2006, 2007 Free Software Foundation, Inc.
  
     This file is part of GCC.
  
***************
*** 30,36 ****
  #ifndef _TMMINTRIN_H_INCLUDED
  #define _TMMINTRIN_H_INCLUDED
  
! #ifdef __SSSE3__
  #include <pmmintrin.h>
  
  static __inline __m128i __attribute__((__always_inline__))
--- 30,40 ----
  #ifndef _TMMINTRIN_H_INCLUDED
  #define _TMMINTRIN_H_INCLUDED
  
! #ifndef __SSSE3__
! # error "SSSE3 instruction set not enabled"
! #else
! 
! /* We need definitions from the SSE3, SSE2 and SSE header files*/
  #include <pmmintrin.h>
  
  static __inline __m128i __attribute__((__always_inline__))
*** ../gcc.orig/./config/i386/sse.md	2011-05-12 12:34:22.000000000 +0300
--- ./config/i386/sse.md	2011-11-15 08:40:11.000000000 +0200
***************
*** 1,5 ****
  ;; GCC machine description for SSE instructions
! ;; Copyright (C) 2005, 2006
  ;; Free Software Foundation, Inc.
  ;;
  ;; This file is part of GCC.
--- 1,5 ----
  ;; GCC machine description for SSE instructions
! ;; Copyright (C) 2005, 2006, 2007
  ;; Free Software Foundation, Inc.
  ;;
  ;; This file is part of GCC.
***************
*** 920,925 ****
--- 920,926 ----
    "cvtsi2ss\t{%2, %0|%0, %2}"
    [(set_attr "type" "sseicvt")
     (set_attr "athlon_decode" "vector,double")
+    (set_attr "amdfam10_decode" "vector,double")
     (set_attr "mode" "SF")])
  
  (define_insn "sse_cvtsi2ssq"
***************
*** 933,938 ****
--- 934,940 ----
    "cvtsi2ssq\t{%2, %0|%0, %2}"
    [(set_attr "type" "sseicvt")
     (set_attr "athlon_decode" "vector,double")
+    (set_attr "amdfam10_decode" "vector,double")
     (set_attr "mode" "SF")])
  
  (define_insn "sse_cvtss2si"
***************
*** 946,951 ****
--- 948,954 ----
    "cvtss2si\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "athlon_decode" "double,vector")
+    (set_attr "amdfam10_decode" "double,double")
     (set_attr "mode" "SI")])
  
  (define_insn "sse_cvtss2siq"
***************
*** 959,964 ****
--- 962,968 ----
    "cvtss2siq\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "athlon_decode" "double,vector")
+    (set_attr "amdfam10_decode" "double,double")
     (set_attr "mode" "DI")])
  
  (define_insn "sse_cvttss2si"
***************
*** 971,976 ****
--- 975,981 ----
    "cvttss2si\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "athlon_decode" "double,vector")
+    (set_attr "amdfam10_decode" "double,double")
     (set_attr "mode" "SI")])
  
  (define_insn "sse_cvttss2siq"
***************
*** 983,988 ****
--- 988,994 ----
    "cvttss2siq\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "athlon_decode" "double,vector")
+    (set_attr "amdfam10_decode" "double,double")
     (set_attr "mode" "DI")])
  
  (define_insn "sse2_cvtdq2ps"
***************
*** 1852,1858 ****
    "cvtsi2sd\t{%2, %0|%0, %2}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "double,direct")])
  
  (define_insn "sse2_cvtsi2sdq"
    [(set (match_operand:V2DF 0 "register_operand" "=x,x")
--- 1858,1865 ----
    "cvtsi2sd\t{%2, %0|%0, %2}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "double,direct")
!    (set_attr "amdfam10_decode" "vector,double")])
  
  (define_insn "sse2_cvtsi2sdq"
    [(set (match_operand:V2DF 0 "register_operand" "=x,x")
***************
*** 1865,1871 ****
    "cvtsi2sdq\t{%2, %0|%0, %2}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "double,direct")])
  
  (define_insn "sse2_cvtsd2si"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
--- 1872,1879 ----
    "cvtsi2sdq\t{%2, %0|%0, %2}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DF")
!    (set_attr "athlon_decode" "double,direct")
!    (set_attr "amdfam10_decode" "vector,double")])
  
  (define_insn "sse2_cvtsd2si"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
***************
*** 1878,1883 ****
--- 1886,1892 ----
    "cvtsd2si\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "athlon_decode" "double,vector")
+    (set_attr "amdfam10_decode" "double,double")
     (set_attr "mode" "SI")])
  
  (define_insn "sse2_cvtsd2siq"
***************
*** 1891,1896 ****
--- 1900,1906 ----
    "cvtsd2siq\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "athlon_decode" "double,vector")
+    (set_attr "amdfam10_decode" "double,double")
     (set_attr "mode" "DI")])
  
  (define_insn "sse2_cvttsd2si"
***************
*** 1903,1909 ****
    "cvttsd2si\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "SI")
!    (set_attr "athlon_decode" "double,vector")])
  
  (define_insn "sse2_cvttsd2siq"
    [(set (match_operand:DI 0 "register_operand" "=r,r")
--- 1913,1920 ----
    "cvttsd2si\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "SI")
!    (set_attr "athlon_decode" "double,vector")
!    (set_attr "amdfam10_decode" "double,double")])
  
  (define_insn "sse2_cvttsd2siq"
    [(set (match_operand:DI 0 "register_operand" "=r,r")
***************
*** 1915,1921 ****
    "cvttsd2siq\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DI")
!    (set_attr "athlon_decode" "double,vector")])
  
  (define_insn "sse2_cvtdq2pd"
    [(set (match_operand:V2DF 0 "register_operand" "=x")
--- 1926,1933 ----
    "cvttsd2siq\t{%1, %0|%0, %1}"
    [(set_attr "type" "sseicvt")
     (set_attr "mode" "DI")
!    (set_attr "athlon_decode" "double,vector")
!    (set_attr "amdfam10_decode" "double,double")])
  
  (define_insn "sse2_cvtdq2pd"
    [(set (match_operand:V2DF 0 "register_operand" "=x")
***************
*** 1946,1952 ****
    "TARGET_SSE2"
    "cvtpd2dq\t{%1, %0|%0, %1}"
    [(set_attr "type" "ssecvt")
!    (set_attr "mode" "TI")])
  
  (define_expand "sse2_cvttpd2dq"
    [(set (match_operand:V4SI 0 "register_operand" "")
--- 1958,1965 ----
    "TARGET_SSE2"
    "cvtpd2dq\t{%1, %0|%0, %1}"
    [(set_attr "type" "ssecvt")
!    (set_attr "mode" "TI")
!    (set_attr "amdfam10_decode" "double")])
  
  (define_expand "sse2_cvttpd2dq"
    [(set (match_operand:V4SI 0 "register_operand" "")
***************
*** 1964,1970 ****
    "TARGET_SSE2"
    "cvttpd2dq\t{%1, %0|%0, %1}"
    [(set_attr "type" "ssecvt")
!    (set_attr "mode" "TI")])
  
  (define_insn "sse2_cvtsd2ss"
    [(set (match_operand:V4SF 0 "register_operand" "=x,x")
--- 1977,1984 ----
    "TARGET_SSE2"
    "cvttpd2dq\t{%1, %0|%0, %1}"
    [(set_attr "type" "ssecvt")
!    (set_attr "mode" "TI")
!    (set_attr "amdfam10_decode" "double")])
  
  (define_insn "sse2_cvtsd2ss"
    [(set (match_operand:V4SF 0 "register_operand" "=x,x")
***************
*** 1978,1997 ****
    "cvtsd2ss\t{%2, %0|%0, %2}"
    [(set_attr "type" "ssecvt")
     (set_attr "athlon_decode" "vector,double")
     (set_attr "mode" "SF")])
  
  (define_insn "sse2_cvtss2sd"
!   [(set (match_operand:V2DF 0 "register_operand" "=x")
  	(vec_merge:V2DF
  	  (float_extend:V2DF
  	    (vec_select:V2SF
! 	      (match_operand:V4SF 2 "nonimmediate_operand" "xm")
  	      (parallel [(const_int 0) (const_int 1)])))
! 	  (match_operand:V2DF 1 "register_operand" "0")
  	  (const_int 1)))]
    "TARGET_SSE2"
    "cvtss2sd\t{%2, %0|%0, %2}"
    [(set_attr "type" "ssecvt")
     (set_attr "mode" "DF")])
  
  (define_expand "sse2_cvtpd2ps"
--- 1992,2013 ----
    "cvtsd2ss\t{%2, %0|%0, %2}"
    [(set_attr "type" "ssecvt")
     (set_attr "athlon_decode" "vector,double")
+    (set_attr "amdfam10_decode" "vector,double")
     (set_attr "mode" "SF")])
  
  (define_insn "sse2_cvtss2sd"
!   [(set (match_operand:V2DF 0 "register_operand" "=x,x")
  	(vec_merge:V2DF
  	  (float_extend:V2DF
  	    (vec_select:V2SF
! 	      (match_operand:V4SF 2 "nonimmediate_operand" "x,m")
  	      (parallel [(const_int 0) (const_int 1)])))
! 	  (match_operand:V2DF 1 "register_operand" "0,0")
  	  (const_int 1)))]
    "TARGET_SSE2"
    "cvtss2sd\t{%2, %0|%0, %2}"
    [(set_attr "type" "ssecvt")
+    (set_attr "amdfam10_decode" "vector,double")
     (set_attr "mode" "DF")])
  
  (define_expand "sse2_cvtpd2ps"
***************
*** 2012,2018 ****
    "TARGET_SSE2"
    "cvtpd2ps\t{%1, %0|%0, %1}"
    [(set_attr "type" "ssecvt")
!    (set_attr "mode" "V4SF")])
  
  (define_insn "sse2_cvtps2pd"
    [(set (match_operand:V2DF 0 "register_operand" "=x")
--- 2028,2035 ----
    "TARGET_SSE2"
    "cvtpd2ps\t{%1, %0|%0, %1}"
    [(set_attr "type" "ssecvt")
!    (set_attr "mode" "V4SF")
!    (set_attr "amdfam10_decode" "double")])
  
  (define_insn "sse2_cvtps2pd"
    [(set (match_operand:V2DF 0 "register_operand" "=x")
***************
*** 2023,2029 ****
    "TARGET_SSE2"
    "cvtps2pd\t{%1, %0|%0, %1}"
    [(set_attr "type" "ssecvt")
!    (set_attr "mode" "V2DF")])
  
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;
--- 2040,2047 ----
    "TARGET_SSE2"
    "cvtps2pd\t{%1, %0|%0, %1}"
    [(set_attr "type" "ssecvt")
!    (set_attr "mode" "V2DF")
!    (set_attr "amdfam10_decode" "direct")])
  
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;
***************
*** 4524,4526 ****
--- 4542,4633 ----
    "pabs<mmxvecsize>\t{%1, %0|%0, %1}";
    [(set_attr "type" "sselog1")
     (set_attr "mode" "DI")])
+ 
+ ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
+ ;;
+ ;; AMD SSE4A instructions
+ ;;
+ ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
+ 
+ (define_insn "sse4a_vmmovntv2df"
+   [(set (match_operand:DF 0 "memory_operand" "=m")
+         (unspec:DF [(vec_select:DF 
+                       (match_operand:V2DF 1 "register_operand" "x")
+                       (parallel [(const_int 0)]))]
+                    UNSPEC_MOVNT))]
+   "TARGET_SSE4A"
+   "movntsd\t{%1, %0|%0, %1}"
+   [(set_attr "type" "ssemov")
+    (set_attr "mode" "DF")])
+ 
+ (define_insn "sse4a_movntdf"
+   [(set (match_operand:DF 0 "memory_operand" "=m")
+         (unspec:DF [(match_operand:DF 1 "register_operand" "x")]
+                    UNSPEC_MOVNT))]
+   "TARGET_SSE4A"
+   "movntsd\t{%1, %0|%0, %1}"
+   [(set_attr "type" "ssemov")
+    (set_attr "mode" "DF")])
+ 
+ (define_insn "sse4a_vmmovntv4sf"
+   [(set (match_operand:SF 0 "memory_operand" "=m")
+ 	(unspec:SF [(vec_select:SF 
+ 	              (match_operand:V4SF 1 "register_operand" "x")
+ 		      (parallel [(const_int 0)]))]
+ 		   UNSPEC_MOVNT))]
+   "TARGET_SSE4A"
+   "movntss\t{%1, %0|%0, %1}"
+   [(set_attr "type" "ssemov")
+    (set_attr "mode" "SF")])
+ 
+ (define_insn "sse4a_movntsf"
+   [(set (match_operand:SF 0 "memory_operand" "=m")
+ 	(unspec:SF [(match_operand:SF 1 "register_operand" "x")]
+ 		   UNSPEC_MOVNT))]
+   "TARGET_SSE4A"
+   "movntss\t{%1, %0|%0, %1}"
+   [(set_attr "type" "ssemov")
+    (set_attr "mode" "SF")])
+ 
+ (define_insn "sse4a_extrqi"
+   [(set (match_operand:V2DI 0 "register_operand" "=x")
+         (unspec:V2DI [(match_operand:V2DI 1 "register_operand" "0")
+                       (match_operand 2 "const_int_operand" "")
+                       (match_operand 3 "const_int_operand" "")]
+                      UNSPEC_EXTRQI))]
+   "TARGET_SSE4A"
+   "extrq\t{%3, %2, %0|%0, %2, %3}"
+   [(set_attr "type" "sse")
+    (set_attr "mode" "TI")])
+ 
+ (define_insn "sse4a_extrq"
+   [(set (match_operand:V2DI 0 "register_operand" "=x")
+         (unspec:V2DI [(match_operand:V2DI 1 "register_operand" "0")
+                       (match_operand:V16QI 2 "register_operand" "x")]
+                      UNSPEC_EXTRQ))]
+   "TARGET_SSE4A"
+   "extrq\t{%2, %0|%0, %2}"
+   [(set_attr "type" "sse")
+    (set_attr "mode" "TI")])
+ 
+ (define_insn "sse4a_insertqi"
+   [(set (match_operand:V2DI 0 "register_operand" "=x")
+         (unspec:V2DI [(match_operand:V2DI 1 "register_operand" "0")
+         	      (match_operand:V2DI 2 "register_operand" "x")
+                       (match_operand 3 "const_int_operand" "")
+                       (match_operand 4 "const_int_operand" "")]
+                      UNSPEC_INSERTQI))]
+   "TARGET_SSE4A"
+   "insertq\t{%4, %3, %2, %0|%0, %2, %3, %4}"
+   [(set_attr "type" "sseins")
+    (set_attr "mode" "TI")])
+ 
+ (define_insn "sse4a_insertq"
+   [(set (match_operand:V2DI 0 "register_operand" "=x")
+         (unspec:V2DI [(match_operand:V2DI 1 "register_operand" "0")
+         	      (match_operand:V2DI 2 "register_operand" "x")]
+         	     UNSPEC_INSERTQ))]
+   "TARGET_SSE4A"
+   "insertq\t{%2, %0|%0, %2}"
+   [(set_attr "type" "sseins")
+    (set_attr "mode" "TI")])
*** ../gcc.orig/./config/i386/i386.opt	2011-05-12 12:34:22.000000000 +0300
--- ./config/i386/i386.opt	2011-11-15 08:40:11.000000000 +0200
***************
*** 1,6 ****
  ; Options for the IA-32 and AMD64 ports of the compiler.
  
! ; Copyright (C) 2005 Free Software Foundation, Inc.
  ;
  ; This file is part of GCC.
  ;
--- 1,6 ----
  ; Options for the IA-32 and AMD64 ports of the compiler.
  
! ; Copyright (C) 2005, 2006, 2007 Free Software Foundation, Inc.
  ;
  ; This file is part of GCC.
  ;
***************
*** 201,206 ****
--- 201,222 ----
  Target Report Mask(SSSE3)
  Support MMX, SSE, SSE2, SSE3 and SSSE3 built-in functions and code generation
  
+ msse4a
+ Target Report Mask(SSE4A)
+ Support MMX, SSE, SSE2, SSE3 and SSE4A built-in functions and code generation
+ 
+ mpopcnt
+ Target Report Mask(POPCNT)
+ Support code generation of popcount instruction for popcount built-ins 
+ namely __builtin_popcount, __builtin_popcountl and __builtin_popcountll
+ 
+ mabm
+ Target Report Mask(ABM)
+ Support code generation of Advanced Bit Manipulation (ABM) instructions,
+ which include popcnt and lzcnt instructions, for popcount and clz built-ins
+ namely __builtin_popcount, __builtin_popcountl, __builtin_popcountll and
+ __builtin_clz, __builtin_clzl, __builtin_clzll
+ 
  msseregparm
  Target RejectNegative Mask(SSEREGPARM)
  Use SSE register passing conventions for SF and DF mode
*** ../gcc.orig/./config/i386/ammintrin.h	2011-11-15 18:46:15.000000000 +0200
--- ./config/i386/ammintrin.h	2011-11-15 08:40:11.000000000 +0200
***************
*** 0 ****
--- 1,73 ----
+ /* Copyright (C) 2007 Free Software Foundation, Inc.
+ 
+    This file is part of GCC.
+ 
+    GCC is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2, or (at your option)
+    any later version.
+ 
+    GCC is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+ 
+    You should have received a copy of the GNU General Public License
+    along with GCC; see the file COPYING.  If not, write to
+    the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+    Boston, MA 02110-1301, USA.  */
+ 
+ /* As a special exception, if you include this header file into source
+    files compiled by GCC, this header file does not by itself cause
+    the resulting executable to be covered by the GNU General Public
+    License.  This exception does not however invalidate any other
+    reasons why the executable file might be covered by the GNU General
+    Public License.  */
+ 
+ /* Implemented from the specification included in the AMD Programmers
+    Manual Update, version 2.x */
+ 
+ #ifndef _AMMINTRIN_H_INCLUDED
+ #define _AMMINTRIN_H_INCLUDED
+ 
+ #ifndef __SSE4A__
+ # error "SSE4A instruction set not enabled"
+ #else
+ 
+ /* We need definitions from the SSE3, SSE2 and SSE header files*/
+ #include <pmmintrin.h>
+ 
+ static __inline void __attribute__((__always_inline__))
+ _mm_stream_sd (double * __P, __m128d __Y)
+ {
+   __builtin_ia32_movntsd (__P, (__v2df) __Y);
+ }
+ 
+ static __inline void __attribute__((__always_inline__))
+ _mm_stream_ss (float * __P, __m128 __Y)
+ {
+   __builtin_ia32_movntss (__P, (__v4sf) __Y);
+ }
+ 
+ static __inline __m128i __attribute__((__always_inline__))
+ _mm_extract_si64 (__m128i __X, __m128i __Y)
+ {
+   return (__m128i) __builtin_ia32_extrq ((__v2di) __X, (__v16qi) __Y);
+ }
+ 
+ #define _mm_extracti_si64(X, I, L) \
+ ((__m128i) __builtin_ia32_extrqi ((__v2di)(X), I, L))
+ 
+ static __inline __m128i __attribute__((__always_inline__))
+ _mm_insert_si64 (__m128i __X,__m128i __Y)
+ {
+   return (__m128i) __builtin_ia32_insertq ((__v2di)__X, (__v2di)__Y);
+ }
+ 
+ #define _mm_inserti_si64(X, Y, I, L) \
+ ((__m128i) __builtin_ia32_insertqi ((__v2di)(X), (__v2di)(Y), I, L))
+ 
+ 
+ #endif /* __SSE4A__ */
+ 
+ #endif /* _AMMINTRIN_H_INCLUDED */
*** ../gcc.orig/./builtins.c	2011-05-12 12:34:25.000000000 +0300
--- ./builtins.c	2011-11-15 08:38:18.000000000 +0200
***************
*** 7324,7329 ****
--- 7324,7334 ----
  	}
      }
  
+   /* Fold floor (x) where x is nonnegative to trunc (x).  */
+   if (tree_expr_nonnegative_p (arg))
+     return build_function_call_expr (mathfn_built_in (TREE_TYPE (arg),
+ 						      BUILT_IN_TRUNC), arglist);
+ 
    return fold_trunc_transparent_mathfn (fndecl, arglist);
  }
  
***************
*** 7442,7447 ****
--- 7447,7464 ----
  	}
      }
  
+   switch (DECL_FUNCTION_CODE (fndecl))
+     {
+     CASE_FLT_FN (BUILT_IN_LFLOOR):
+     CASE_FLT_FN (BUILT_IN_LLFLOOR):
+       /* Fold lfloor (x) where x is nonnegative to FIX_TRUNC (x).  */
+       if (tree_expr_nonnegative_p (arg))
+ 	return fold_build1 (FIX_TRUNC_EXPR, TREE_TYPE (TREE_TYPE (fndecl)),
+ 			    arg);
+       break;
+     default:;
+     }
+ 
    return fold_fixed_mathfn (fndecl, arglist);
  }
  
*** ../gcc.orig/./tree-ssa-pre.c	2011-05-12 12:34:26.000000000 +0300
--- ./tree-ssa-pre.c	2011-11-15 08:39:35.000000000 +0200
***************
*** 1076,1081 ****
--- 1076,1082 ----
  	    tree newexpr;
  	    tree vh = get_value_handle (expr);
  	    bool listchanged = false;
+ 	    bool invariantarg = false;
  	    VEC (tree, gc) *vuses = VALUE_HANDLE_VUSES (vh);
  	    VEC (tree, gc) *tvuses;
  
***************
*** 1134,1143 ****
--- 1135,1160 ----
  		    if (newval != oldval)
  		      {
  			listchanged = true;
+ 			invariantarg |= is_gimple_min_invariant (newval);
  			TREE_VALUE (newwalker) = get_value_handle (newval);
  		      }
  		  }
  	      }
+ 
+ 	    /* In case of new invariant args we might try to fold the call
+ 	       again.  */
+ 	    if (invariantarg)
+ 	      {
+ 		tree tmp = fold_ternary (CALL_EXPR, TREE_TYPE (expr),
+ 					 newop0, newarglist, newop2);
+ 		if (tmp)
+ 		  {
+ 		    STRIP_TYPE_NOPS (tmp);
+ 		    if (is_gimple_min_invariant (tmp))
+ 		      return tmp;
+ 		  }
+ 	      }
+ 
  	    if (listchanged)
  	      vn_lookup_or_add (newarglist, NULL);
  
*** ../gcc.orig/./ChangeLog	2011-05-12 12:34:25.000000000 +0300
--- ./ChangeLog	2011-11-15 09:57:31.000000000 +0200
***************
*** 803,808 ****
--- 803,820 ----
  	* omp-low.c (expand_omp_parallel): If child_cfun->cfg, free dominators,
  	post dominators and cleanup cfg before returning.
  
+ 2007-04-12  Richard Guenther  <rguenther@suse.de>
+ 
+ 	PR tree-optimization/24689
+ 	PR tree-optimization/31307
+ 	* fold-const.c (operand_equal_p): Compare INTEGER_CST array
+ 	indices by value.
+ 	* gimplify.c (canonicalize_addr_expr): To be consistent with
+ 	gimplify_compound_lval only set operands two and three of
+ 	ARRAY_REFs if they are not gimple_min_invariant.  This makes
+ 	it never at this place.
+ 	* tree-ssa-ccp.c (maybe_fold_offset_to_array_ref): Likewise.
+ 
  2007-04-11  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>
  
  	* pa.c (pa_som_asm_init_sections): Ensure that cfun->machine is not
***************
*** 909,914 ****
--- 921,932 ----
  	sync_double_compare_and_swap_ccdi_pic): Use "SD" as constraint
  	for operand 3.
  
+ 2007-03-28  Dwarakanath Rajagopal  <dwarak.rajagopal@amd.com>
+ 
+ 	* config.gcc: Accept barcelona as a variant of amdfam10.
+ 	* config/i386/i386.c (override_options): Likewise.
+ 	* doc/invoke.texi: Likewise.
+ 
  2007-03-28  Mike Stump  <mrs@apple.com>
  
  	* config/darwin9.h (ASM_OUTPUT_ALIGNED_COMMON): Add.
***************
*** 1745,1750 ****
--- 1763,1922 ----
  	* config/rs6000/darwin-tramp.asm (__trampoline_setup): Call
  	__enable_execute_stack on completion.
  
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 
+ 	* config/i386/athlon.md (athlon_fldxf_k8, athlon_fld_k8,
+ 	athlon_fstxf_k8, athlon_fst_k8, athlon_fist, athlon_fmov,
+ 	athlon_fadd_load, athlon_fadd_load_k8, athlon_fadd, athlon_fmul,
+ 	athlon_fmul_load, athlon_fmul_load_k8, athlon_fsgn,
+ 	athlon_fdiv_load, athlon_fdiv_load_k8, athlon_fdiv_k8,
+ 	athlon_fpspc_load, athlon_fpspc, athlon_fcmov_load,
+ 	athlon_fcmov_load_k8, athlon_fcmov_k8, athlon_fcomi_load_k8,
+ 	athlon_fcomi, athlon_fcom_load_k8, athlon_fcom): Added amdfam10.
+ 
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 
+ 	* config/i386/i386.md (x86_sahf_1, cmpfp_i_mixed, cmpfp_i_sse,
+ 	cmpfp_i_i387, cmpfp_iu_mixed, cmpfp_iu_sse, cmpfp_iu_387,
+ 	swapsi, swaphi_1, swapqi_1, swapdi_rex64, fix_truncsfdi_sse,
+ 	fix_truncdfdi_sse, fix_truncsfsi_sse, fix_truncdfsi_sse,
+ 	x86_fldcw_1, floatsisf2_mixed, floatsisf2_sse, floatdisf2_mixed,
+ 	floatdisf2_sse, floatsidf2_mixed, floatsidf2_sse,
+ 	floatdidf2_mixed, floatdidf2_sse, muldi3_1_rex64, mulsi3_1,
+ 	mulsi3_1_zext, mulhi3_1, mulqi3_1, umulqihi3_1, mulqihi3_insn,
+ 	umulditi3_insn, umulsidi3_insn, mulditi3_insn, mulsidi3_insn,
+ 	umuldi3_highpart_rex64, umulsi3_highpart_insn,
+ 	umulsi3_highpart_zext, smuldi3_highpart_rex64,
+ 	smulsi3_highpart_insn, smulsi3_highpart_zext, x86_64_shld,
+ 	x86_shld_1, x86_64_shrd, sqrtsf2_mixed, sqrtsf2_sse,
+ 	sqrtsf2_i387, sqrtdf2_mixed, sqrtdf2_sse, sqrtdf2_i387,
+ 	sqrtextendsfdf2_i387, sqrtxf2, sqrtextendsfxf2_i387,
+ 	sqrtextenddfxf2_i387): Added amdfam10_decode.
+ 	
+ 	* config/i386/athlon.md (athlon_idirect_amdfam10,
+ 	athlon_ivector_amdfam10, athlon_idirect_load_amdfam10,
+ 	athlon_ivector_load_amdfam10, athlon_idirect_both_amdfam10,
+ 	athlon_ivector_both_amdfam10, athlon_idirect_store_amdfam10,
+ 	athlon_ivector_store_amdfam10): New define_insn_reservation.
+ 	(athlon_idirect_loadmov, athlon_idirect_movstore): Added
+ 	amdfam10.
+ 
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 
+ 	* config/i386/athlon.md (athlon_call_amdfam10,
+ 	athlon_pop_amdfam10, athlon_lea_amdfam10): New
+ 	define_insn_reservation.
+ 	(athlon_branch, athlon_push, athlon_leave_k8, athlon_imul_k8,
+ 	athlon_imul_k8_DI, athlon_imul_mem_k8, athlon_imul_mem_k8_DI,
+ 	athlon_idiv, athlon_idiv_mem, athlon_str): Added amdfam10.
+ 
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 
+ 	* config/i386/athlon.md (athlon_sseld_amdfam10,
+ 	athlon_mmxld_amdfam10, athlon_ssest_amdfam10,
+ 	athlon_mmxssest_short_amdfam10): New define_insn_reservation.
+ 
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 
+ 	* config/i386/athlon.md (athlon_sseins_amdfam10): New
+ 	define_insn_reservation.
+ 	* config/i386/i386.md (sseins): Added sseins to define_attr type
+ 	and define_attr unit.
+ 	* config/i386/sse.md: Set type attribute to sseins for insertq
+ 	and insertqi.
+ 
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 
+ 	* config/i386/athlon.md (sselog_load_amdfam10, sselog_amdfam10,
+ 	ssecmpvector_load_amdfam10, ssecmpvector_amdfam10,
+ 	ssecomi_load_amdfam10, ssecomi_amdfam10,
+ 	sseaddvector_load_amdfam10, sseaddvector_amdfam10): New
+ 	define_insn_reservation.
+ 	(ssecmp_load_k8, ssecmp, sseadd_load_k8, seadd): Added amdfam10.
+ 
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 
+ 	* config/i386/athlon.md (cvtss2sd_load_amdfam10,
+ 	cvtss2sd_amdfam10, cvtps2pd_load_amdfam10, cvtps2pd_amdfam10,
+ 	cvtsi2sd_load_amdfam10, cvtsi2ss_load_amdfam10,
+ 	cvtsi2sd_amdfam10, cvtsi2ss_amdfam10, cvtsd2ss_load_amdfam10,
+ 	cvtsd2ss_amdfam10, cvtpd2ps_load_amdfam10, cvtpd2ps_amdfam10,
+ 	cvtsX2si_load_amdfam10, cvtsX2si_amdfam10): New 
+ 	define_insn_reservation.
+ 
+ 	* config/i386/sse.md (cvtsi2ss, cvtsi2ssq, cvtss2si,
+ 	cvtss2siq, cvttss2si, cvttss2siq, cvtsi2sd, cvtsi2sdq,
+ 	cvtsd2si, cvtsd2siq, cvttsd2si, cvttsd2siq,
+ 	cvtpd2dq, cvttpd2dq, cvtsd2ss, cvtss2sd,
+ 	cvtpd2ps, cvtps2pd): Added amdfam10_decode attribute.
+ 
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 
+ 	* config/i386/athlon.md (athlon_ssedivvector_amdfam10,
+ 	athlon_ssedivvector_load_amdfam10, athlon_ssemulvector_amdfam10,
+ 	athlon_ssemulvector_load_amdfam10): New define_insn_reservation.
+ 	(athlon_ssediv, athlon_ssediv_load_k8, athlon_ssemul,
+ 	athlon_ssemul_load_k8): Added amdfam10.
+ 
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 
+ 	* config/i386/i386.h (TARGET_SSE_UNALIGNED_MOVE_OPTIMAL): New macro.
+ 	(x86_sse_unaligned_move_optimal): New variable.
+ 	
+ 	* config/i386/i386.c (x86_sse_unaligned_move_optimal): Enable for  
+ 	m_AMDFAM10.
+ 	(ix86_expand_vector_move_misalign): Add code to generate movupd/movups
+ 	for unaligned vector SSE double/single precision loads for AMDFAM10.
+ 
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 
+ 	* config/i386/i386.h (TARGET_AMDFAM10): New macro.
+ 	(TARGET_CPU_CPP_BUILTINS): Add code for amdfam10.
+ 	Define TARGET_CPU_DEFAULT_amdfam10.
+ 	(TARGET_CPU_DEFAULT_NAMES): Add amdfam10.
+ 	(processor_type): Add PROCESSOR_AMDFAM10.	
+ 	
+ 	* config/i386/i386.md: Add amdfam10 as a new cpu attribute to match
+ 	processor_type in config/i386/i386.h.
+ 	Enable imul peepholes for TARGET_AMDFAM10.
+ 	
+ 	* config.gcc: Add support for --with-cpu option for amdfam10.
+ 	
+ 	* config/i386/i386.c (amdfam10_cost): New variable.
+ 	(m_AMDFAM10): New macro.
+ 	(m_ATHLON_K8_AMDFAM10): New macro.
+ 	(x86_use_leave, x86_push_memory, x86_movx, x86_unroll_strlen,
+ 	x86_cmove, x86_3dnow_a, x86_deep_branch, x86_use_simode_fiop,
+ 	x86_promote_QImode, x86_integer_DFmode_moves,
+ 	x86_partial_reg_dependency, x86_memory_mismatch_stall, 
+ 	x86_accumulate_outgoing_args, x86_arch_always_fancy_math_387,
+ 	x86_sse_partial_reg_dependency, x86_sse_typeless_stores,
+ 	x86_use_ffreep, x86_use_incdec, x86_four_jump_limit,
+ 	x86_schedule, x86_use_bt, x86_cmpxchg16b, x86_pad_returns):
+ 	Enable/disable for amdfam10.
+ 	(override_options): Add amdfam10_cost to processor_target_table.
+ 	Set up PROCESSOR_AMDFAM10 for amdfam10 entry in 
+ 	processor_alias_table.
+ 	(ix86_issue_rate): Add PROCESSOR_AMDFAM10.
+ 	(ix86_adjust_cost): Add code for amdfam10.
+ 
+ 2007-02-05	Harsha Jagasia	<harsha.jagasia@amd.com>
+ 	
+ 	* config/i386/i386.opt: Add new Advanced Bit Manipulation (-mabm)
+ 	instruction set feature flag. Add new (-mpopcnt) flag for popcnt 
+ 	instruction. Add new SSE4A (-msse4a) instruction set feature flag.
+ 	* config/i386/i386.h: Add builtin definition for SSE4A.
+ 	* config/i386/i386.md: Add support for ABM instructions 
+ 	(popcnt and lzcnt).
+ 	* config/i386/sse.md: Add support for SSE4A instructions
+ 	(movntss, movntsd, extrq, insertq).
+ 	* config/i386/i386.c: Add support for ABM and SSE4A builtins.
+ 	Add -march=amdfam10 flag.
+ 	* config/i386/ammintrin.h: Add support for SSE4A intrinsics.
+ 	* doc/invoke.texi: Add documentation on flags for sse4a, abm, popcnt
+ 	and amdfam10.
+ 	* doc/extend.texi: Add documentation for SSE4A builtins.
+ 
  2007-02-05  Bob Wilson  <bob.wilson@acm.org>
  
  	* config/xtensa/xtensa.c (constantpool_mem_p): Skip over SUBREGs.
*** ../gcc.orig/./config.gcc	2011-05-12 12:34:26.000000000 +0300
--- ./config.gcc	2011-11-15 09:41:08.000000000 +0200
***************
*** 269,280 ****
  i[34567]86-*-*)
  	cpu_type=i386
  	extra_headers="mmintrin.h mm3dnow.h xmmintrin.h emmintrin.h
! 		       pmmintrin.h tmmintrin.h"
  	;;
  x86_64-*-*)
  	cpu_type=i386
  	extra_headers="mmintrin.h mm3dnow.h xmmintrin.h emmintrin.h
! 		       pmmintrin.h tmmintrin.h"
  	need_64bit_hwint=yes
  	;;
  ia64-*-*)
--- 269,280 ----
  i[34567]86-*-*)
  	cpu_type=i386
  	extra_headers="mmintrin.h mm3dnow.h xmmintrin.h emmintrin.h
! 		       pmmintrin.h tmmintrin.h ammintrin.h"
  	;;
  x86_64-*-*)
  	cpu_type=i386
  	extra_headers="mmintrin.h mm3dnow.h xmmintrin.h emmintrin.h
! 		       pmmintrin.h tmmintrin.h ammintrin.h"
  	need_64bit_hwint=yes
  	;;
  ia64-*-*)
***************
*** 1209,1222 ****
  		# FIXME: -m64 for i[34567]86-*-* should be allowed just
  		# like -m32 for x86_64-*-*.
  		case X"${with_cpu}" in
! 		Xgeneric|Xcore2|Xnocona|Xx86-64|Xk8|Xopteron|Xathlon64|Xathlon-fx)
  			;;
  		X)
  			with_cpu=generic
  			;;
  		*)
  			echo "Unsupported CPU used in --with-cpu=$with_cpu, supported values:" 1>&2
! 			echo "generic core2 nocona x86-64 k8 opteron athlon64 athlon-fx" 1>&2
  			exit 1
  			;;
  		esac
--- 1209,1222 ----
  		# FIXME: -m64 for i[34567]86-*-* should be allowed just
  		# like -m32 for x86_64-*-*.
  		case X"${with_cpu}" in
! 		Xgeneric|Xcore2|Xnocona|Xx86-64|Xamdfam10|Xbarcelona|Xk8|Xopteron|Xathlon64|Xathlon-fx)
  			;;
  		X)
  			with_cpu=generic
  			;;
  		*)
  			echo "Unsupported CPU used in --with-cpu=$with_cpu, supported values:" 1>&2
! 			echo "generic core2 nocona x86-64 amdfam10 barcelona k8 opteron athlon64 athlon-fx" 1>&2
  			exit 1
  			;;
  		esac
***************
*** 2515,2520 ****
--- 2515,2523 ----
        ;;
      i686-*-* | i786-*-*)
        case ${target_noncanonical} in
+         amdfam10-*|barcelona-*)
+           with_cpu=amdfam10
+           ;;
          k8-*|opteron-*|athlon_64-*)
            with_cpu=k8
            ;;
***************
*** 2555,2560 ****
--- 2558,2566 ----
        ;;
      x86_64-*-*)
        case ${target_noncanonical} in
+         amdfam10-*|barcelona-*)
+           with_cpu=amdfam10
+           ;;
          k8-*|opteron-*|athlon_64-*)
            with_cpu=k8
            ;;
***************
*** 2795,2801 ****
  				esac
  				# OK
  				;;
! 			"" | k8 | opteron | athlon64 | athlon-fx | nocona | core2 | generic)
  				# OK
  				;;
  			*)
--- 2801,2807 ----
  				esac
  				# OK
  				;;
! 			"" | amdfam10 | barcelona | k8 | opteron | athlon64 | athlon-fx | nocona | core2 | generic)
  				# OK
  				;;
  			*)
*** ../gcc.orig/./fold-const.c	2011-05-12 12:34:25.000000000 +0300
--- ./fold-const.c	2011-11-15 09:57:31.000000000 +0200
***************
*** 2802,2810 ****
  
  	case ARRAY_REF:
  	case ARRAY_RANGE_REF:
! 	  /* Operands 2 and 3 may be null.  */
  	  return (OP_SAME (0)
! 		  && OP_SAME (1)
  		  && OP_SAME_WITH_NULL (2)
  		  && OP_SAME_WITH_NULL (3));
  
--- 2802,2814 ----
  
  	case ARRAY_REF:
  	case ARRAY_RANGE_REF:
! 	  /* Operands 2 and 3 may be null.
! 	     Compare the array index by value if it is constant first as we
! 	     may have different types but same value here.  */
  	  return (OP_SAME (0)
! 		  && (tree_int_cst_equal (TREE_OPERAND (arg0, 1),
! 					  TREE_OPERAND (arg1, 1))
! 		      || OP_SAME (1))
  		  && OP_SAME_WITH_NULL (2)
  		  && OP_SAME_WITH_NULL (3));
  
*** ../gcc.orig/./tree-ssa-ccp.c	2011-05-12 12:34:25.000000000 +0300
--- ./tree-ssa-ccp.c	2011-11-15 09:57:33.000000000 +0200
***************
*** 1621,1629 ****
    if (!integer_zerop (elt_offset))
      idx = int_const_binop (PLUS_EXPR, idx, elt_offset, 0);
  
!   return build4 (ARRAY_REF, orig_type, base, idx, min_idx,
! 		 size_int (tree_low_cst (elt_size, 1)
! 			   / (TYPE_ALIGN_UNIT (elt_type))));
  }
  
  
--- 1621,1627 ----
    if (!integer_zerop (elt_offset))
      idx = int_const_binop (PLUS_EXPR, idx, elt_offset, 0);
  
!   return build4 (ARRAY_REF, orig_type, base, idx, NULL_TREE, NULL_TREE);
  }
  
  
*** ../gcc.orig/./gimplify.c	2011-05-12 12:34:26.000000000 +0300
--- ./gimplify.c	2011-11-15 09:57:33.000000000 +0200
***************
*** 1600,1608 ****
    /* All checks succeeded.  Build a new node to merge the cast.  */
    *expr_p = build4 (ARRAY_REF, dctype, obj_expr,
  		    TYPE_MIN_VALUE (TYPE_DOMAIN (datype)),
! 		    TYPE_MIN_VALUE (TYPE_DOMAIN (datype)),
! 		    size_binop (EXACT_DIV_EXPR, TYPE_SIZE_UNIT (dctype),
! 				size_int (TYPE_ALIGN_UNIT (dctype))));
    *expr_p = build1 (ADDR_EXPR, ctype, *expr_p);
  }
  
--- 1600,1606 ----
    /* All checks succeeded.  Build a new node to merge the cast.  */
    *expr_p = build4 (ARRAY_REF, dctype, obj_expr,
  		    TYPE_MIN_VALUE (TYPE_DOMAIN (datype)),
! 		    NULL_TREE, NULL_TREE);
    *expr_p = build1 (ADDR_EXPR, ctype, *expr_p);
  }
  
